

-- | Copyright  : Will Thompson and Iñaki García Etxebarria
-- License    : LGPL-2.1
-- Maintainer : Iñaki García Etxebarria

#if (MIN_VERSION_haskell_gi_overloading(1,0,0) && !defined(__HADDOCK_VERSION__))
#define ENABLE_OVERLOADING
#endif

module GI.HarfBuzz.Flags
    ( 

 -- * Flags


-- ** AatLayoutFeatureSelectorT #flag:AatLayoutFeatureSelectorT#

    AatLayoutFeatureSelectorT(..)           ,


-- ** AatLayoutFeatureTypeT #flag:AatLayoutFeatureTypeT#

    AatLayoutFeatureTypeT(..)               ,


-- ** BufferDiffFlagsT #flag:BufferDiffFlagsT#

    BufferDiffFlagsT(..)                    ,


-- ** BufferFlagsT #flag:BufferFlagsT#

    BufferFlagsT(..)                        ,


-- ** BufferSerializeFlagsT #flag:BufferSerializeFlagsT#

    BufferSerializeFlagsT(..)               ,


-- ** BufferSerializeFormatT #flag:BufferSerializeFormatT#

    BufferSerializeFormatT(..)              ,


-- ** GlyphFlagsT #flag:GlyphFlagsT#

    GlyphFlagsT(..)                         ,


-- ** OtColorPaletteFlagsT #flag:OtColorPaletteFlagsT#

    OtColorPaletteFlagsT(..)                ,


-- ** OtLayoutBaselineTagT #flag:OtLayoutBaselineTagT#

    OtLayoutBaselineTagT(..)                ,


-- ** OtMathGlyphPartFlagsT #flag:OtMathGlyphPartFlagsT#

    OtMathGlyphPartFlagsT(..)               ,


-- ** OtMetaTagT #flag:OtMetaTagT#

    OtMetaTagT(..)                          ,


-- ** OtMetricsTagT #flag:OtMetricsTagT#

    OtMetricsTagT(..)                       ,


-- ** OtVarAxisFlagsT #flag:OtVarAxisFlagsT#

    OtVarAxisFlagsT(..)                     ,


-- ** ScriptT #flag:ScriptT#

    ScriptT(..)                             ,


-- ** StyleTagT #flag:StyleTagT#

    StyleTagT(..)                           ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.BasicTypes as B.Types
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GArray as B.GArray
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GHashTable as B.GHT
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.GI.Base.Signals as B.Signals
import qualified Control.Monad.IO.Class as MIO
import qualified Data.Coerce as Coerce
import qualified Data.Text as T
import qualified Data.Kind as DK
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL
import qualified GHC.Records as R
import qualified Data.Word as DW
import qualified Data.Int as DI
import qualified System.Posix.Types as SPT
import qualified Foreign.C.Types as FCT

-- Workaround for https://gitlab.haskell.org/ghc/ghc/-/issues/23392
#if MIN_VERSION_base(4,18,0)

#else

#endif

-- Flags style_tag_t
-- | Defined by <https://docs.microsoft.com/en-us/typography/opentype/spec/dvaraxisreg OpenType Design-Variation Axis Tag Registry>.
-- 
-- /Since: 3.0.0/
data StyleTagT = 
      StyleTagTBStyleTagItalic
    -- ^ Used to vary between non-italic and italic.
    -- A value of 0 can be interpreted as \"Roman\" (non-italic); a value of 1 can
    -- be interpreted as (fully) italic.
    | StyleTagTBStyleTagOpticalSize
    -- ^ Used to vary design to suit different text sizes.
    -- Non-zero. Values can be interpreted as text size, in points.
    | StyleTagTBStyleTagSlantAngle
    -- ^ Used to vary between upright and slanted text. Values
    -- must be greater than -90 and less than +90. Values can be interpreted as
    -- the angle, in counter-clockwise degrees, of oblique slant from whatever the
    -- designer considers to be upright for that font design. Typical right-leaning
    -- Italic fonts have a negative slant angle (typically around -12)
    | StyleTagTBStyleTagSlantRatio
    -- ^ same as /@hBSTYLETAGSLANTANGLE@/ expression as ratio.
    -- Typical right-leaning Italic fonts have a positive slant ratio (typically around 0.2)
    | StyleTagTBStyleTagWidth
    -- ^ Used to vary width of text from narrower to wider.
    -- Non-zero. Values can be interpreted as a percentage of whatever the font
    -- designer considers “normal width” for that font design.
    | StyleTagTBStyleTagWeight
    -- ^ Used to vary stroke thicknesses or other design details
    -- to give variation from lighter to blacker. Values can be interpreted in direct
    -- comparison to values for usWeightClass in the OS\/2 table,
    -- or the CSS font-weight property.
    | AnotherStyleTagT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum StyleTagT where
    fromEnum StyleTagTBStyleTagItalic = 1769234796
    fromEnum StyleTagTBStyleTagOpticalSize = 1869640570
    fromEnum StyleTagTBStyleTagSlantAngle = 1936486004
    fromEnum StyleTagTBStyleTagSlantRatio = 1399615092
    fromEnum StyleTagTBStyleTagWidth = 2003072104
    fromEnum StyleTagTBStyleTagWeight = 2003265652
    fromEnum (AnotherStyleTagT k) = k

    toEnum 1769234796 = StyleTagTBStyleTagItalic
    toEnum 1869640570 = StyleTagTBStyleTagOpticalSize
    toEnum 1936486004 = StyleTagTBStyleTagSlantAngle
    toEnum 1399615092 = StyleTagTBStyleTagSlantRatio
    toEnum 2003072104 = StyleTagTBStyleTagWidth
    toEnum 2003265652 = StyleTagTBStyleTagWeight
    toEnum k = AnotherStyleTagT k

instance P.Ord StyleTagT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag StyleTagT

-- Flags script_t
-- | Data type for scripts. Each t'GI.HarfBuzz.Flags.ScriptT'\'s value is an @/hb_tag_t/@ corresponding
-- to the four-letter values defined by <https://unicode.org/iso15924/ ISO 15924>.
-- 
-- See also the Script (sc) property of the Unicode Character Database.
data ScriptT = 
      ScriptTBScriptCommon
    -- ^ @Zyyy@
    | ScriptTBScriptInherited
    -- ^ @Zinh@
    | ScriptTBScriptUnknown
    -- ^ @Zzzz@
    | ScriptTBScriptArabic
    -- ^ @Arab@
    | ScriptTBScriptArmenian
    -- ^ @Armn@
    | ScriptTBScriptBengali
    -- ^ @Beng@
    | ScriptTBScriptCyrillic
    -- ^ @Cyrl@
    | ScriptTBScriptDevanagari
    -- ^ @Deva@
    | ScriptTBScriptGeorgian
    -- ^ @Geor@
    | ScriptTBScriptGreek
    -- ^ @Grek@
    | ScriptTBScriptGujarati
    -- ^ @Gujr@
    | ScriptTBScriptGurmukhi
    -- ^ @Guru@
    | ScriptTBScriptHangul
    -- ^ @Hang@
    | ScriptTBScriptHan
    -- ^ @Hani@
    | ScriptTBScriptHebrew
    -- ^ @Hebr@
    | ScriptTBScriptHiragana
    -- ^ @Hira@
    | ScriptTBScriptKannada
    -- ^ @Knda@
    | ScriptTBScriptKatakana
    -- ^ @Kana@
    | ScriptTBScriptLao
    -- ^ @Laoo@
    | ScriptTBScriptLatin
    -- ^ @Latn@
    | ScriptTBScriptMalayalam
    -- ^ @Mlym@
    | ScriptTBScriptOriya
    -- ^ @Orya@
    | ScriptTBScriptTamil
    -- ^ @Taml@
    | ScriptTBScriptTelugu
    -- ^ @Telu@
    | ScriptTBScriptThai
    -- ^ @Thai@
    | ScriptTBScriptTibetan
    -- ^ @Tibt@
    | ScriptTBScriptBopomofo
    -- ^ @Bopo@
    | ScriptTBScriptBraille
    -- ^ @Brai@
    | ScriptTBScriptCanadianSyllabics
    -- ^ @Cans@
    | ScriptTBScriptCherokee
    -- ^ @Cher@
    | ScriptTBScriptEthiopic
    -- ^ @Ethi@
    | ScriptTBScriptKhmer
    -- ^ @Khmr@
    | ScriptTBScriptMongolian
    -- ^ @Mong@
    | ScriptTBScriptMyanmar
    -- ^ @Mymr@
    | ScriptTBScriptOgham
    -- ^ @Ogam@
    | ScriptTBScriptRunic
    -- ^ @Runr@
    | ScriptTBScriptSinhala
    -- ^ @Sinh@
    | ScriptTBScriptSyriac
    -- ^ @Syrc@
    | ScriptTBScriptThaana
    -- ^ @Thaa@
    | ScriptTBScriptYi
    -- ^ @Yiii@
    | ScriptTBScriptDeseret
    -- ^ @Dsrt@
    | ScriptTBScriptGothic
    -- ^ @Goth@
    | ScriptTBScriptOldItalic
    -- ^ @Ital@
    | ScriptTBScriptBuhid
    -- ^ @Buhd@
    | ScriptTBScriptHanunoo
    -- ^ @Hano@
    | ScriptTBScriptTagalog
    -- ^ @Tglg@
    | ScriptTBScriptTagbanwa
    -- ^ @Tagb@
    | ScriptTBScriptCypriot
    -- ^ @Cprt@
    | ScriptTBScriptLimbu
    -- ^ @Limb@
    | ScriptTBScriptLinearB
    -- ^ @Linb@
    | ScriptTBScriptOsmanya
    -- ^ @Osma@
    | ScriptTBScriptShavian
    -- ^ @Shaw@
    | ScriptTBScriptTaiLe
    -- ^ @Tale@
    | ScriptTBScriptUgaritic
    -- ^ @Ugar@
    | ScriptTBScriptBuginese
    -- ^ @Bugi@
    | ScriptTBScriptCoptic
    -- ^ @Copt@
    | ScriptTBScriptGlagolitic
    -- ^ @Glag@
    | ScriptTBScriptKharoshthi
    -- ^ @Khar@
    | ScriptTBScriptNewTaiLue
    -- ^ @Talu@
    | ScriptTBScriptOldPersian
    -- ^ @Xpeo@
    | ScriptTBScriptSylotiNagri
    -- ^ @Sylo@
    | ScriptTBScriptTifinagh
    -- ^ @Tfng@
    | ScriptTBScriptBalinese
    -- ^ @Bali@
    | ScriptTBScriptCuneiform
    -- ^ @Xsux@
    | ScriptTBScriptNko
    -- ^ @Nkoo@
    | ScriptTBScriptPhagsPa
    -- ^ @Phag@
    | ScriptTBScriptPhoenician
    -- ^ @Phnx@
    | ScriptTBScriptCarian
    -- ^ @Cari@
    | ScriptTBScriptCham
    -- ^ @Cham@
    | ScriptTBScriptKayahLi
    -- ^ @Kali@
    | ScriptTBScriptLepcha
    -- ^ @Lepc@
    | ScriptTBScriptLycian
    -- ^ @Lyci@
    | ScriptTBScriptLydian
    -- ^ @Lydi@
    | ScriptTBScriptOlChiki
    -- ^ @Olck@
    | ScriptTBScriptRejang
    -- ^ @Rjng@
    | ScriptTBScriptSaurashtra
    -- ^ @Saur@
    | ScriptTBScriptSundanese
    -- ^ @Sund@
    | ScriptTBScriptVai
    -- ^ @Vaii@
    | ScriptTBScriptAvestan
    -- ^ @Avst@
    | ScriptTBScriptBamum
    -- ^ @Bamu@
    | ScriptTBScriptEgyptianHieroglyphs
    -- ^ @Egyp@
    | ScriptTBScriptImperialAramaic
    -- ^ @Armi@
    | ScriptTBScriptInscriptionalPahlavi
    -- ^ @Phli@
    | ScriptTBScriptInscriptionalParthian
    -- ^ @Prti@
    | ScriptTBScriptJavanese
    -- ^ @Java@
    | ScriptTBScriptKaithi
    -- ^ @Kthi@
    | ScriptTBScriptLisu
    -- ^ @Lisu@
    | ScriptTBScriptMeeteiMayek
    -- ^ @Mtei@
    | ScriptTBScriptOldSouthArabian
    -- ^ @Sarb@
    | ScriptTBScriptOldTurkic
    -- ^ @Orkh@
    | ScriptTBScriptSamaritan
    -- ^ @Samr@
    | ScriptTBScriptTaiTham
    -- ^ @Lana@
    | ScriptTBScriptTaiViet
    -- ^ @Tavt@
    | ScriptTBScriptBatak
    -- ^ @Batk@
    | ScriptTBScriptBrahmi
    -- ^ @Brah@
    | ScriptTBScriptMandaic
    -- ^ @Mand@
    | ScriptTBScriptChakma
    -- ^ @Cakm@
    | ScriptTBScriptMeroiticCursive
    -- ^ @Merc@
    | ScriptTBScriptMeroiticHieroglyphs
    -- ^ @Mero@
    | ScriptTBScriptMiao
    -- ^ @Plrd@
    | ScriptTBScriptSharada
    -- ^ @Shrd@
    | ScriptTBScriptSoraSompeng
    -- ^ @Sora@
    | ScriptTBScriptTakri
    -- ^ @Takr@
    | ScriptTBScriptBassaVah
    -- ^ @Bass@, Since: 0.9.30
    | ScriptTBScriptCaucasianAlbanian
    -- ^ @Aghb@, Since: 0.9.30
    | ScriptTBScriptDuployan
    -- ^ @Dupl@, Since: 0.9.30
    | ScriptTBScriptElbasan
    -- ^ @Elba@, Since: 0.9.30
    | ScriptTBScriptGrantha
    -- ^ @Gran@, Since: 0.9.30
    | ScriptTBScriptKhojki
    -- ^ @Khoj@, Since: 0.9.30
    | ScriptTBScriptKhudawadi
    -- ^ @Sind@, Since: 0.9.30
    | ScriptTBScriptLinearA
    -- ^ @Lina@, Since: 0.9.30
    | ScriptTBScriptMahajani
    -- ^ @Mahj@, Since: 0.9.30
    | ScriptTBScriptManichaean
    -- ^ @Mani@, Since: 0.9.30
    | ScriptTBScriptMendeKikakui
    -- ^ @Mend@, Since: 0.9.30
    | ScriptTBScriptModi
    -- ^ @Modi@, Since: 0.9.30
    | ScriptTBScriptMro
    -- ^ @Mroo@, Since: 0.9.30
    | ScriptTBScriptNabataean
    -- ^ @Nbat@, Since: 0.9.30
    | ScriptTBScriptOldNorthArabian
    -- ^ @Narb@, Since: 0.9.30
    | ScriptTBScriptOldPermic
    -- ^ @Perm@, Since: 0.9.30
    | ScriptTBScriptPahawhHmong
    -- ^ @Hmng@, Since: 0.9.30
    | ScriptTBScriptPalmyrene
    -- ^ @Palm@, Since: 0.9.30
    | ScriptTBScriptPauCinHau
    -- ^ @Pauc@, Since: 0.9.30
    | ScriptTBScriptPsalterPahlavi
    -- ^ @Phlp@, Since: 0.9.30
    | ScriptTBScriptSiddham
    -- ^ @Sidd@, Since: 0.9.30
    | ScriptTBScriptTirhuta
    -- ^ @Tirh@, Since: 0.9.30
    | ScriptTBScriptWarangCiti
    -- ^ @Wara@, Since: 0.9.30
    | ScriptTBScriptAhom
    -- ^ @Ahom@, Since: 0.9.30
    | ScriptTBScriptAnatolianHieroglyphs
    -- ^ @Hluw@, Since: 0.9.30
    | ScriptTBScriptHatran
    -- ^ @Hatr@, Since: 0.9.30
    | ScriptTBScriptMultani
    -- ^ @Mult@, Since: 0.9.30
    | ScriptTBScriptOldHungarian
    -- ^ @Hung@, Since: 0.9.30
    | ScriptTBScriptSignwriting
    -- ^ @Sgnw@, Since: 0.9.30
    | ScriptTBScriptAdlam
    -- ^ @Adlm@, Since: 1.3.0
    | ScriptTBScriptBhaiksuki
    -- ^ @Bhks@, Since: 1.3.0
    | ScriptTBScriptMarchen
    -- ^ @Marc@, Since: 1.3.0
    | ScriptTBScriptOsage
    -- ^ @Osge@, Since: 1.3.0
    | ScriptTBScriptTangut
    -- ^ @Tang@, Since: 1.3.0
    | ScriptTBScriptNewa
    -- ^ @Newa@, Since: 1.3.0
    | ScriptTBScriptMasaramGondi
    -- ^ @Gonm@, Since: 1.6.0
    | ScriptTBScriptNushu
    -- ^ @Nshu@, Since: 1.6.0
    | ScriptTBScriptSoyombo
    -- ^ @Soyo@, Since: 1.6.0
    | ScriptTBScriptZanabazarSquare
    -- ^ @Zanb@, Since: 1.6.0
    | ScriptTBScriptDogra
    -- ^ @Dogr@, Since: 1.8.0
    | ScriptTBScriptGunjalaGondi
    -- ^ @Gong@, Since: 1.8.0
    | ScriptTBScriptHanifiRohingya
    -- ^ @Rohg@, Since: 1.8.0
    | ScriptTBScriptMakasar
    -- ^ @Maka@, Since: 1.8.0
    | ScriptTBScriptMedefaidrin
    -- ^ @Medf@, Since: 1.8.0
    | ScriptTBScriptOldSogdian
    -- ^ @Sogo@, Since: 1.8.0
    | ScriptTBScriptSogdian
    -- ^ @Sogd@, Since: 1.8.0
    | ScriptTBScriptElymaic
    -- ^ @Elym@, Since: 2.4.0
    | ScriptTBScriptNandinagari
    -- ^ @Nand@, Since: 2.4.0
    | ScriptTBScriptNyiakengPuachueHmong
    -- ^ @Hmnp@, Since: 2.4.0
    | ScriptTBScriptWancho
    -- ^ @Wcho@, Since: 2.4.0
    | ScriptTBScriptChorasmian
    -- ^ @Chrs@, Since: 2.6.7
    | ScriptTBScriptDivesAkuru
    -- ^ @Diak@, Since: 2.6.7
    | ScriptTBScriptKhitanSmallScript
    -- ^ @Kits@, Since: 2.6.7
    | ScriptTBScriptYezidi
    -- ^ @Yezi@, Since: 2.6.7
    | ScriptTBScriptCyproMinoan
    -- ^ @Cpmn@, Since: 3.0.0
    | ScriptTBScriptOldUyghur
    -- ^ @Ougr@, Since: 3.0.0
    | ScriptTBScriptTangsa
    -- ^ @Tnsa@, Since: 3.0.0
    | ScriptTBScriptToto
    -- ^ @Toto@, Since: 3.0.0
    | ScriptTBScriptVithkuqi
    -- ^ @Vith@, Since: 3.0.0
    | ScriptTBScriptMath
    -- ^ @Zmth@, Since: 3.4.0
    | ScriptTBScriptKawi
    -- ^ @Kawi@, Since: 5.2.0
    | ScriptTBScriptNagMundari
    -- ^ @Nagm@, Since: 5.2.0
    | ScriptTBScriptGaray
    -- ^ @Gara@, Since: 10.0.0
    | ScriptTBScriptGurungKhema
    -- ^ @Gukh@, Since: 10.0.0
    | ScriptTBScriptKiratRai
    -- ^ @Krai@, Since: 10.0.0
    | ScriptTBScriptOlOnal
    -- ^ @Onao@, Since: 10.0.0
    | ScriptTBScriptSunuwar
    -- ^ @Sunu@, Since: 10.0.0
    | ScriptTBScriptTodhri
    -- ^ @Todr@, Since: 10.0.0
    | ScriptTBScriptTuluTigalari
    -- ^ @Tutg@, Since: 10.0.0
    | ScriptTBScriptInvalid
    -- ^ No script set
    | AnotherScriptT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum ScriptT where
    fromEnum ScriptTBScriptCommon = 1517910393
    fromEnum ScriptTBScriptInherited = 1516858984
    fromEnum ScriptTBScriptUnknown = 1517976186
    fromEnum ScriptTBScriptArabic = 1098015074
    fromEnum ScriptTBScriptArmenian = 1098018158
    fromEnum ScriptTBScriptBengali = 1113943655
    fromEnum ScriptTBScriptCyrillic = 1132032620
    fromEnum ScriptTBScriptDevanagari = 1147500129
    fromEnum ScriptTBScriptGeorgian = 1197830002
    fromEnum ScriptTBScriptGreek = 1198679403
    fromEnum ScriptTBScriptGujarati = 1198877298
    fromEnum ScriptTBScriptGurmukhi = 1198879349
    fromEnum ScriptTBScriptHangul = 1214344807
    fromEnum ScriptTBScriptHan = 1214344809
    fromEnum ScriptTBScriptHebrew = 1214603890
    fromEnum ScriptTBScriptHiragana = 1214870113
    fromEnum ScriptTBScriptKannada = 1265525857
    fromEnum ScriptTBScriptKatakana = 1264676449
    fromEnum ScriptTBScriptLao = 1281453935
    fromEnum ScriptTBScriptLatin = 1281455214
    fromEnum ScriptTBScriptMalayalam = 1298954605
    fromEnum ScriptTBScriptOriya = 1332902241
    fromEnum ScriptTBScriptTamil = 1415671148
    fromEnum ScriptTBScriptTelugu = 1415933045
    fromEnum ScriptTBScriptThai = 1416126825
    fromEnum ScriptTBScriptTibetan = 1416192628
    fromEnum ScriptTBScriptBopomofo = 1114599535
    fromEnum ScriptTBScriptBraille = 1114792297
    fromEnum ScriptTBScriptCanadianSyllabics = 1130458739
    fromEnum ScriptTBScriptCherokee = 1130915186
    fromEnum ScriptTBScriptEthiopic = 1165256809
    fromEnum ScriptTBScriptKhmer = 1265134962
    fromEnum ScriptTBScriptMongolian = 1299148391
    fromEnum ScriptTBScriptMyanmar = 1299803506
    fromEnum ScriptTBScriptOgham = 1332175213
    fromEnum ScriptTBScriptRunic = 1383427698
    fromEnum ScriptTBScriptSinhala = 1399418472
    fromEnum ScriptTBScriptSyriac = 1400468067
    fromEnum ScriptTBScriptThaana = 1416126817
    fromEnum ScriptTBScriptYi = 1500080489
    fromEnum ScriptTBScriptDeseret = 1148416628
    fromEnum ScriptTBScriptGothic = 1198486632
    fromEnum ScriptTBScriptOldItalic = 1232363884
    fromEnum ScriptTBScriptBuhid = 1114990692
    fromEnum ScriptTBScriptHanunoo = 1214344815
    fromEnum ScriptTBScriptTagalog = 1416064103
    fromEnum ScriptTBScriptTagbanwa = 1415669602
    fromEnum ScriptTBScriptCypriot = 1131442804
    fromEnum ScriptTBScriptLimbu = 1281977698
    fromEnum ScriptTBScriptLinearB = 1281977954
    fromEnum ScriptTBScriptOsmanya = 1332964705
    fromEnum ScriptTBScriptShavian = 1399349623
    fromEnum ScriptTBScriptTaiLe = 1415670885
    fromEnum ScriptTBScriptUgaritic = 1432838514
    fromEnum ScriptTBScriptBuginese = 1114990441
    fromEnum ScriptTBScriptCoptic = 1131376756
    fromEnum ScriptTBScriptGlagolitic = 1198285159
    fromEnum ScriptTBScriptKharoshthi = 1265131890
    fromEnum ScriptTBScriptNewTaiLue = 1415670901
    fromEnum ScriptTBScriptOldPersian = 1483761007
    fromEnum ScriptTBScriptSylotiNagri = 1400466543
    fromEnum ScriptTBScriptTifinagh = 1415999079
    fromEnum ScriptTBScriptBalinese = 1113681001
    fromEnum ScriptTBScriptCuneiform = 1483961720
    fromEnum ScriptTBScriptNko = 1315663727
    fromEnum ScriptTBScriptPhagsPa = 1349017959
    fromEnum ScriptTBScriptPhoenician = 1349021304
    fromEnum ScriptTBScriptCarian = 1130459753
    fromEnum ScriptTBScriptCham = 1130914157
    fromEnum ScriptTBScriptKayahLi = 1264675945
    fromEnum ScriptTBScriptLepcha = 1281716323
    fromEnum ScriptTBScriptLycian = 1283023721
    fromEnum ScriptTBScriptLydian = 1283023977
    fromEnum ScriptTBScriptOlChiki = 1332503403
    fromEnum ScriptTBScriptRejang = 1382706791
    fromEnum ScriptTBScriptSaurashtra = 1398895986
    fromEnum ScriptTBScriptSundanese = 1400204900
    fromEnum ScriptTBScriptVai = 1449224553
    fromEnum ScriptTBScriptAvestan = 1098281844
    fromEnum ScriptTBScriptBamum = 1113681269
    fromEnum ScriptTBScriptEgyptianHieroglyphs = 1164409200
    fromEnum ScriptTBScriptImperialAramaic = 1098018153
    fromEnum ScriptTBScriptInscriptionalPahlavi = 1349020777
    fromEnum ScriptTBScriptInscriptionalParthian = 1349678185
    fromEnum ScriptTBScriptJavanese = 1247901281
    fromEnum ScriptTBScriptKaithi = 1265920105
    fromEnum ScriptTBScriptLisu = 1281979253
    fromEnum ScriptTBScriptMeeteiMayek = 1299473769
    fromEnum ScriptTBScriptOldSouthArabian = 1398895202
    fromEnum ScriptTBScriptOldTurkic = 1332898664
    fromEnum ScriptTBScriptSamaritan = 1398893938
    fromEnum ScriptTBScriptTaiTham = 1281453665
    fromEnum ScriptTBScriptTaiViet = 1415673460
    fromEnum ScriptTBScriptBatak = 1113683051
    fromEnum ScriptTBScriptBrahmi = 1114792296
    fromEnum ScriptTBScriptMandaic = 1298230884
    fromEnum ScriptTBScriptChakma = 1130457965
    fromEnum ScriptTBScriptMeroiticCursive = 1298494051
    fromEnum ScriptTBScriptMeroiticHieroglyphs = 1298494063
    fromEnum ScriptTBScriptMiao = 1349284452
    fromEnum ScriptTBScriptSharada = 1399353956
    fromEnum ScriptTBScriptSoraSompeng = 1399812705
    fromEnum ScriptTBScriptTakri = 1415670642
    fromEnum ScriptTBScriptBassaVah = 1113682803
    fromEnum ScriptTBScriptCaucasianAlbanian = 1097295970
    fromEnum ScriptTBScriptDuployan = 1148547180
    fromEnum ScriptTBScriptElbasan = 1164730977
    fromEnum ScriptTBScriptGrantha = 1198678382
    fromEnum ScriptTBScriptKhojki = 1265135466
    fromEnum ScriptTBScriptKhudawadi = 1399418468
    fromEnum ScriptTBScriptLinearA = 1281977953
    fromEnum ScriptTBScriptMahajani = 1298229354
    fromEnum ScriptTBScriptManichaean = 1298230889
    fromEnum ScriptTBScriptMendeKikakui = 1298493028
    fromEnum ScriptTBScriptModi = 1299145833
    fromEnum ScriptTBScriptMro = 1299345263
    fromEnum ScriptTBScriptNabataean = 1315070324
    fromEnum ScriptTBScriptOldNorthArabian = 1315009122
    fromEnum ScriptTBScriptOldPermic = 1348825709
    fromEnum ScriptTBScriptPahawhHmong = 1215131239
    fromEnum ScriptTBScriptPalmyrene = 1348562029
    fromEnum ScriptTBScriptPauCinHau = 1348564323
    fromEnum ScriptTBScriptPsalterPahlavi = 1349020784
    fromEnum ScriptTBScriptSiddham = 1399415908
    fromEnum ScriptTBScriptTirhuta = 1416196712
    fromEnum ScriptTBScriptWarangCiti = 1466004065
    fromEnum ScriptTBScriptAhom = 1097363309
    fromEnum ScriptTBScriptAnatolianHieroglyphs = 1215067511
    fromEnum ScriptTBScriptHatran = 1214346354
    fromEnum ScriptTBScriptMultani = 1299541108
    fromEnum ScriptTBScriptOldHungarian = 1215655527
    fromEnum ScriptTBScriptSignwriting = 1399287415
    fromEnum ScriptTBScriptAdlam = 1097100397
    fromEnum ScriptTBScriptBhaiksuki = 1114139507
    fromEnum ScriptTBScriptMarchen = 1298231907
    fromEnum ScriptTBScriptOsage = 1332963173
    fromEnum ScriptTBScriptTangut = 1415671399
    fromEnum ScriptTBScriptNewa = 1315272545
    fromEnum ScriptTBScriptMasaramGondi = 1198485101
    fromEnum ScriptTBScriptNushu = 1316186229
    fromEnum ScriptTBScriptSoyombo = 1399814511
    fromEnum ScriptTBScriptZanabazarSquare = 1516334690
    fromEnum ScriptTBScriptDogra = 1148151666
    fromEnum ScriptTBScriptGunjalaGondi = 1198485095
    fromEnum ScriptTBScriptHanifiRohingya = 1383032935
    fromEnum ScriptTBScriptMakasar = 1298230113
    fromEnum ScriptTBScriptMedefaidrin = 1298490470
    fromEnum ScriptTBScriptOldSogdian = 1399809903
    fromEnum ScriptTBScriptSogdian = 1399809892
    fromEnum ScriptTBScriptElymaic = 1164736877
    fromEnum ScriptTBScriptNandinagari = 1315008100
    fromEnum ScriptTBScriptNyiakengPuachueHmong = 1215131248
    fromEnum ScriptTBScriptWancho = 1466132591
    fromEnum ScriptTBScriptChorasmian = 1130918515
    fromEnum ScriptTBScriptDivesAkuru = 1147756907
    fromEnum ScriptTBScriptKhitanSmallScript = 1265202291
    fromEnum ScriptTBScriptYezidi = 1499822697
    fromEnum ScriptTBScriptCyproMinoan = 1131441518
    fromEnum ScriptTBScriptOldUyghur = 1333094258
    fromEnum ScriptTBScriptTangsa = 1416524641
    fromEnum ScriptTBScriptToto = 1416590447
    fromEnum ScriptTBScriptVithkuqi = 1449751656
    fromEnum ScriptTBScriptMath = 1517122664
    fromEnum ScriptTBScriptKawi = 1264678761
    fromEnum ScriptTBScriptNagMundari = 1315006317
    fromEnum ScriptTBScriptGaray = 1197568609
    fromEnum ScriptTBScriptGurungKhema = 1198877544
    fromEnum ScriptTBScriptKiratRai = 1265787241
    fromEnum ScriptTBScriptOlOnal = 1332633967
    fromEnum ScriptTBScriptSunuwar = 1400204917
    fromEnum ScriptTBScriptTodhri = 1416586354
    fromEnum ScriptTBScriptTuluTigalari = 1416983655
    fromEnum ScriptTBScriptInvalid = 0
    fromEnum (AnotherScriptT k) = k

    toEnum 1517910393 = ScriptTBScriptCommon
    toEnum 1516858984 = ScriptTBScriptInherited
    toEnum 1517976186 = ScriptTBScriptUnknown
    toEnum 1098015074 = ScriptTBScriptArabic
    toEnum 1098018158 = ScriptTBScriptArmenian
    toEnum 1113943655 = ScriptTBScriptBengali
    toEnum 1132032620 = ScriptTBScriptCyrillic
    toEnum 1147500129 = ScriptTBScriptDevanagari
    toEnum 1197830002 = ScriptTBScriptGeorgian
    toEnum 1198679403 = ScriptTBScriptGreek
    toEnum 1198877298 = ScriptTBScriptGujarati
    toEnum 1198879349 = ScriptTBScriptGurmukhi
    toEnum 1214344807 = ScriptTBScriptHangul
    toEnum 1214344809 = ScriptTBScriptHan
    toEnum 1214603890 = ScriptTBScriptHebrew
    toEnum 1214870113 = ScriptTBScriptHiragana
    toEnum 1265525857 = ScriptTBScriptKannada
    toEnum 1264676449 = ScriptTBScriptKatakana
    toEnum 1281453935 = ScriptTBScriptLao
    toEnum 1281455214 = ScriptTBScriptLatin
    toEnum 1298954605 = ScriptTBScriptMalayalam
    toEnum 1332902241 = ScriptTBScriptOriya
    toEnum 1415671148 = ScriptTBScriptTamil
    toEnum 1415933045 = ScriptTBScriptTelugu
    toEnum 1416126825 = ScriptTBScriptThai
    toEnum 1416192628 = ScriptTBScriptTibetan
    toEnum 1114599535 = ScriptTBScriptBopomofo
    toEnum 1114792297 = ScriptTBScriptBraille
    toEnum 1130458739 = ScriptTBScriptCanadianSyllabics
    toEnum 1130915186 = ScriptTBScriptCherokee
    toEnum 1165256809 = ScriptTBScriptEthiopic
    toEnum 1265134962 = ScriptTBScriptKhmer
    toEnum 1299148391 = ScriptTBScriptMongolian
    toEnum 1299803506 = ScriptTBScriptMyanmar
    toEnum 1332175213 = ScriptTBScriptOgham
    toEnum 1383427698 = ScriptTBScriptRunic
    toEnum 1399418472 = ScriptTBScriptSinhala
    toEnum 1400468067 = ScriptTBScriptSyriac
    toEnum 1416126817 = ScriptTBScriptThaana
    toEnum 1500080489 = ScriptTBScriptYi
    toEnum 1148416628 = ScriptTBScriptDeseret
    toEnum 1198486632 = ScriptTBScriptGothic
    toEnum 1232363884 = ScriptTBScriptOldItalic
    toEnum 1114990692 = ScriptTBScriptBuhid
    toEnum 1214344815 = ScriptTBScriptHanunoo
    toEnum 1416064103 = ScriptTBScriptTagalog
    toEnum 1415669602 = ScriptTBScriptTagbanwa
    toEnum 1131442804 = ScriptTBScriptCypriot
    toEnum 1281977698 = ScriptTBScriptLimbu
    toEnum 1281977954 = ScriptTBScriptLinearB
    toEnum 1332964705 = ScriptTBScriptOsmanya
    toEnum 1399349623 = ScriptTBScriptShavian
    toEnum 1415670885 = ScriptTBScriptTaiLe
    toEnum 1432838514 = ScriptTBScriptUgaritic
    toEnum 1114990441 = ScriptTBScriptBuginese
    toEnum 1131376756 = ScriptTBScriptCoptic
    toEnum 1198285159 = ScriptTBScriptGlagolitic
    toEnum 1265131890 = ScriptTBScriptKharoshthi
    toEnum 1415670901 = ScriptTBScriptNewTaiLue
    toEnum 1483761007 = ScriptTBScriptOldPersian
    toEnum 1400466543 = ScriptTBScriptSylotiNagri
    toEnum 1415999079 = ScriptTBScriptTifinagh
    toEnum 1113681001 = ScriptTBScriptBalinese
    toEnum 1483961720 = ScriptTBScriptCuneiform
    toEnum 1315663727 = ScriptTBScriptNko
    toEnum 1349017959 = ScriptTBScriptPhagsPa
    toEnum 1349021304 = ScriptTBScriptPhoenician
    toEnum 1130459753 = ScriptTBScriptCarian
    toEnum 1130914157 = ScriptTBScriptCham
    toEnum 1264675945 = ScriptTBScriptKayahLi
    toEnum 1281716323 = ScriptTBScriptLepcha
    toEnum 1283023721 = ScriptTBScriptLycian
    toEnum 1283023977 = ScriptTBScriptLydian
    toEnum 1332503403 = ScriptTBScriptOlChiki
    toEnum 1382706791 = ScriptTBScriptRejang
    toEnum 1398895986 = ScriptTBScriptSaurashtra
    toEnum 1400204900 = ScriptTBScriptSundanese
    toEnum 1449224553 = ScriptTBScriptVai
    toEnum 1098281844 = ScriptTBScriptAvestan
    toEnum 1113681269 = ScriptTBScriptBamum
    toEnum 1164409200 = ScriptTBScriptEgyptianHieroglyphs
    toEnum 1098018153 = ScriptTBScriptImperialAramaic
    toEnum 1349020777 = ScriptTBScriptInscriptionalPahlavi
    toEnum 1349678185 = ScriptTBScriptInscriptionalParthian
    toEnum 1247901281 = ScriptTBScriptJavanese
    toEnum 1265920105 = ScriptTBScriptKaithi
    toEnum 1281979253 = ScriptTBScriptLisu
    toEnum 1299473769 = ScriptTBScriptMeeteiMayek
    toEnum 1398895202 = ScriptTBScriptOldSouthArabian
    toEnum 1332898664 = ScriptTBScriptOldTurkic
    toEnum 1398893938 = ScriptTBScriptSamaritan
    toEnum 1281453665 = ScriptTBScriptTaiTham
    toEnum 1415673460 = ScriptTBScriptTaiViet
    toEnum 1113683051 = ScriptTBScriptBatak
    toEnum 1114792296 = ScriptTBScriptBrahmi
    toEnum 1298230884 = ScriptTBScriptMandaic
    toEnum 1130457965 = ScriptTBScriptChakma
    toEnum 1298494051 = ScriptTBScriptMeroiticCursive
    toEnum 1298494063 = ScriptTBScriptMeroiticHieroglyphs
    toEnum 1349284452 = ScriptTBScriptMiao
    toEnum 1399353956 = ScriptTBScriptSharada
    toEnum 1399812705 = ScriptTBScriptSoraSompeng
    toEnum 1415670642 = ScriptTBScriptTakri
    toEnum 1113682803 = ScriptTBScriptBassaVah
    toEnum 1097295970 = ScriptTBScriptCaucasianAlbanian
    toEnum 1148547180 = ScriptTBScriptDuployan
    toEnum 1164730977 = ScriptTBScriptElbasan
    toEnum 1198678382 = ScriptTBScriptGrantha
    toEnum 1265135466 = ScriptTBScriptKhojki
    toEnum 1399418468 = ScriptTBScriptKhudawadi
    toEnum 1281977953 = ScriptTBScriptLinearA
    toEnum 1298229354 = ScriptTBScriptMahajani
    toEnum 1298230889 = ScriptTBScriptManichaean
    toEnum 1298493028 = ScriptTBScriptMendeKikakui
    toEnum 1299145833 = ScriptTBScriptModi
    toEnum 1299345263 = ScriptTBScriptMro
    toEnum 1315070324 = ScriptTBScriptNabataean
    toEnum 1315009122 = ScriptTBScriptOldNorthArabian
    toEnum 1348825709 = ScriptTBScriptOldPermic
    toEnum 1215131239 = ScriptTBScriptPahawhHmong
    toEnum 1348562029 = ScriptTBScriptPalmyrene
    toEnum 1348564323 = ScriptTBScriptPauCinHau
    toEnum 1349020784 = ScriptTBScriptPsalterPahlavi
    toEnum 1399415908 = ScriptTBScriptSiddham
    toEnum 1416196712 = ScriptTBScriptTirhuta
    toEnum 1466004065 = ScriptTBScriptWarangCiti
    toEnum 1097363309 = ScriptTBScriptAhom
    toEnum 1215067511 = ScriptTBScriptAnatolianHieroglyphs
    toEnum 1214346354 = ScriptTBScriptHatran
    toEnum 1299541108 = ScriptTBScriptMultani
    toEnum 1215655527 = ScriptTBScriptOldHungarian
    toEnum 1399287415 = ScriptTBScriptSignwriting
    toEnum 1097100397 = ScriptTBScriptAdlam
    toEnum 1114139507 = ScriptTBScriptBhaiksuki
    toEnum 1298231907 = ScriptTBScriptMarchen
    toEnum 1332963173 = ScriptTBScriptOsage
    toEnum 1415671399 = ScriptTBScriptTangut
    toEnum 1315272545 = ScriptTBScriptNewa
    toEnum 1198485101 = ScriptTBScriptMasaramGondi
    toEnum 1316186229 = ScriptTBScriptNushu
    toEnum 1399814511 = ScriptTBScriptSoyombo
    toEnum 1516334690 = ScriptTBScriptZanabazarSquare
    toEnum 1148151666 = ScriptTBScriptDogra
    toEnum 1198485095 = ScriptTBScriptGunjalaGondi
    toEnum 1383032935 = ScriptTBScriptHanifiRohingya
    toEnum 1298230113 = ScriptTBScriptMakasar
    toEnum 1298490470 = ScriptTBScriptMedefaidrin
    toEnum 1399809903 = ScriptTBScriptOldSogdian
    toEnum 1399809892 = ScriptTBScriptSogdian
    toEnum 1164736877 = ScriptTBScriptElymaic
    toEnum 1315008100 = ScriptTBScriptNandinagari
    toEnum 1215131248 = ScriptTBScriptNyiakengPuachueHmong
    toEnum 1466132591 = ScriptTBScriptWancho
    toEnum 1130918515 = ScriptTBScriptChorasmian
    toEnum 1147756907 = ScriptTBScriptDivesAkuru
    toEnum 1265202291 = ScriptTBScriptKhitanSmallScript
    toEnum 1499822697 = ScriptTBScriptYezidi
    toEnum 1131441518 = ScriptTBScriptCyproMinoan
    toEnum 1333094258 = ScriptTBScriptOldUyghur
    toEnum 1416524641 = ScriptTBScriptTangsa
    toEnum 1416590447 = ScriptTBScriptToto
    toEnum 1449751656 = ScriptTBScriptVithkuqi
    toEnum 1517122664 = ScriptTBScriptMath
    toEnum 1264678761 = ScriptTBScriptKawi
    toEnum 1315006317 = ScriptTBScriptNagMundari
    toEnum 1197568609 = ScriptTBScriptGaray
    toEnum 1198877544 = ScriptTBScriptGurungKhema
    toEnum 1265787241 = ScriptTBScriptKiratRai
    toEnum 1332633967 = ScriptTBScriptOlOnal
    toEnum 1400204917 = ScriptTBScriptSunuwar
    toEnum 1416586354 = ScriptTBScriptTodhri
    toEnum 1416983655 = ScriptTBScriptTuluTigalari
    toEnum 0 = ScriptTBScriptInvalid
    toEnum k = AnotherScriptT k

instance P.Ord ScriptT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag ScriptT

-- Flags ot_var_axis_flags_t
-- | Flags for t'GI.HarfBuzz.Structs.OtVarAxisInfoT.OtVarAxisInfoT'.
-- 
-- /Since: 2.2.0/
data OtVarAxisFlagsT = 
      OtVarAxisFlagsTBOtVarAxisFlagHidden
    -- ^ The axis should not be exposed directly in user interfaces.
    | AnotherOtVarAxisFlagsT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum OtVarAxisFlagsT where
    fromEnum OtVarAxisFlagsTBOtVarAxisFlagHidden = 1
    fromEnum (AnotherOtVarAxisFlagsT k) = k

    toEnum 1 = OtVarAxisFlagsTBOtVarAxisFlagHidden
    toEnum k = AnotherOtVarAxisFlagsT k

instance P.Ord OtVarAxisFlagsT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag OtVarAxisFlagsT

-- Flags ot_metrics_tag_t
-- | Metric tags corresponding to <https://docs.microsoft.com/en-us/typography/opentype/spec/mvar#value-tags MVAR Value
-- Tags>
-- 
-- /Since: 2.6.0/
data OtMetricsTagT = 
      OtMetricsTagTBOtMetricsTagHorizontalAscender
    -- ^ horizontal ascender.
    | OtMetricsTagTBOtMetricsTagHorizontalDescender
    -- ^ horizontal descender.
    | OtMetricsTagTBOtMetricsTagHorizontalLineGap
    -- ^ horizontal line gap.
    | OtMetricsTagTBOtMetricsTagHorizontalClippingAscent
    -- ^ horizontal clipping ascent.
    | OtMetricsTagTBOtMetricsTagHorizontalClippingDescent
    -- ^ horizontal clipping descent.
    | OtMetricsTagTBOtMetricsTagVerticalAscender
    -- ^ vertical ascender.
    | OtMetricsTagTBOtMetricsTagVerticalDescender
    -- ^ vertical descender.
    | OtMetricsTagTBOtMetricsTagVerticalLineGap
    -- ^ vertical line gap.
    | OtMetricsTagTBOtMetricsTagHorizontalCaretRise
    -- ^ horizontal caret rise.
    | OtMetricsTagTBOtMetricsTagHorizontalCaretRun
    -- ^ horizontal caret run.
    | OtMetricsTagTBOtMetricsTagHorizontalCaretOffset
    -- ^ horizontal caret offset.
    | OtMetricsTagTBOtMetricsTagVerticalCaretRise
    -- ^ vertical caret rise.
    | OtMetricsTagTBOtMetricsTagVerticalCaretRun
    -- ^ vertical caret run.
    | OtMetricsTagTBOtMetricsTagVerticalCaretOffset
    -- ^ vertical caret offset.
    | OtMetricsTagTBOtMetricsTagXHeight
    -- ^ x height.
    | OtMetricsTagTBOtMetricsTagCapHeight
    -- ^ cap height.
    | OtMetricsTagTBOtMetricsTagSubscriptEmXSize
    -- ^ subscript em x size.
    | OtMetricsTagTBOtMetricsTagSubscriptEmYSize
    -- ^ subscript em y size.
    | OtMetricsTagTBOtMetricsTagSubscriptEmXOffset
    -- ^ subscript em x offset.
    | OtMetricsTagTBOtMetricsTagSubscriptEmYOffset
    -- ^ subscript em y offset.
    | OtMetricsTagTBOtMetricsTagSuperscriptEmXSize
    -- ^ superscript em x size.
    | OtMetricsTagTBOtMetricsTagSuperscriptEmYSize
    -- ^ superscript em y size.
    | OtMetricsTagTBOtMetricsTagSuperscriptEmXOffset
    -- ^ superscript em x offset.
    | OtMetricsTagTBOtMetricsTagSuperscriptEmYOffset
    -- ^ superscript em y offset.
    | OtMetricsTagTBOtMetricsTagStrikeoutSize
    -- ^ strikeout size.
    | OtMetricsTagTBOtMetricsTagStrikeoutOffset
    -- ^ strikeout offset.
    | OtMetricsTagTBOtMetricsTagUnderlineSize
    -- ^ underline size.
    | OtMetricsTagTBOtMetricsTagUnderlineOffset
    -- ^ underline offset.
    | AnotherOtMetricsTagT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum OtMetricsTagT where
    fromEnum OtMetricsTagTBOtMetricsTagHorizontalAscender = 1751216995
    fromEnum OtMetricsTagTBOtMetricsTagHorizontalDescender = 1751413603
    fromEnum OtMetricsTagTBOtMetricsTagHorizontalLineGap = 1751934832
    fromEnum OtMetricsTagTBOtMetricsTagHorizontalClippingAscent = 1751346273
    fromEnum OtMetricsTagTBOtMetricsTagHorizontalClippingDescent = 1751346276
    fromEnum OtMetricsTagTBOtMetricsTagVerticalAscender = 1986098019
    fromEnum OtMetricsTagTBOtMetricsTagVerticalDescender = 1986294627
    fromEnum OtMetricsTagTBOtMetricsTagVerticalLineGap = 1986815856
    fromEnum OtMetricsTagTBOtMetricsTagHorizontalCaretRise = 1751347827
    fromEnum OtMetricsTagTBOtMetricsTagHorizontalCaretRun = 1751347822
    fromEnum OtMetricsTagTBOtMetricsTagHorizontalCaretOffset = 1751347046
    fromEnum OtMetricsTagTBOtMetricsTagVerticalCaretRise = 1986228851
    fromEnum OtMetricsTagTBOtMetricsTagVerticalCaretRun = 1986228846
    fromEnum OtMetricsTagTBOtMetricsTagVerticalCaretOffset = 1986228070
    fromEnum OtMetricsTagTBOtMetricsTagXHeight = 2020108148
    fromEnum OtMetricsTagTBOtMetricsTagCapHeight = 1668311156
    fromEnum OtMetricsTagTBOtMetricsTagSubscriptEmXSize = 1935833203
    fromEnum OtMetricsTagTBOtMetricsTagSubscriptEmYSize = 1935833459
    fromEnum OtMetricsTagTBOtMetricsTagSubscriptEmXOffset = 1935833199
    fromEnum OtMetricsTagTBOtMetricsTagSubscriptEmYOffset = 1935833455
    fromEnum OtMetricsTagTBOtMetricsTagSuperscriptEmXSize = 1936750707
    fromEnum OtMetricsTagTBOtMetricsTagSuperscriptEmYSize = 1936750963
    fromEnum OtMetricsTagTBOtMetricsTagSuperscriptEmXOffset = 1936750703
    fromEnum OtMetricsTagTBOtMetricsTagSuperscriptEmYOffset = 1936750959
    fromEnum OtMetricsTagTBOtMetricsTagStrikeoutSize = 1937011315
    fromEnum OtMetricsTagTBOtMetricsTagStrikeoutOffset = 1937011311
    fromEnum OtMetricsTagTBOtMetricsTagUnderlineSize = 1970168947
    fromEnum OtMetricsTagTBOtMetricsTagUnderlineOffset = 1970168943
    fromEnum (AnotherOtMetricsTagT k) = k

    toEnum 1751216995 = OtMetricsTagTBOtMetricsTagHorizontalAscender
    toEnum 1751413603 = OtMetricsTagTBOtMetricsTagHorizontalDescender
    toEnum 1751934832 = OtMetricsTagTBOtMetricsTagHorizontalLineGap
    toEnum 1751346273 = OtMetricsTagTBOtMetricsTagHorizontalClippingAscent
    toEnum 1751346276 = OtMetricsTagTBOtMetricsTagHorizontalClippingDescent
    toEnum 1986098019 = OtMetricsTagTBOtMetricsTagVerticalAscender
    toEnum 1986294627 = OtMetricsTagTBOtMetricsTagVerticalDescender
    toEnum 1986815856 = OtMetricsTagTBOtMetricsTagVerticalLineGap
    toEnum 1751347827 = OtMetricsTagTBOtMetricsTagHorizontalCaretRise
    toEnum 1751347822 = OtMetricsTagTBOtMetricsTagHorizontalCaretRun
    toEnum 1751347046 = OtMetricsTagTBOtMetricsTagHorizontalCaretOffset
    toEnum 1986228851 = OtMetricsTagTBOtMetricsTagVerticalCaretRise
    toEnum 1986228846 = OtMetricsTagTBOtMetricsTagVerticalCaretRun
    toEnum 1986228070 = OtMetricsTagTBOtMetricsTagVerticalCaretOffset
    toEnum 2020108148 = OtMetricsTagTBOtMetricsTagXHeight
    toEnum 1668311156 = OtMetricsTagTBOtMetricsTagCapHeight
    toEnum 1935833203 = OtMetricsTagTBOtMetricsTagSubscriptEmXSize
    toEnum 1935833459 = OtMetricsTagTBOtMetricsTagSubscriptEmYSize
    toEnum 1935833199 = OtMetricsTagTBOtMetricsTagSubscriptEmXOffset
    toEnum 1935833455 = OtMetricsTagTBOtMetricsTagSubscriptEmYOffset
    toEnum 1936750707 = OtMetricsTagTBOtMetricsTagSuperscriptEmXSize
    toEnum 1936750963 = OtMetricsTagTBOtMetricsTagSuperscriptEmYSize
    toEnum 1936750703 = OtMetricsTagTBOtMetricsTagSuperscriptEmXOffset
    toEnum 1936750959 = OtMetricsTagTBOtMetricsTagSuperscriptEmYOffset
    toEnum 1937011315 = OtMetricsTagTBOtMetricsTagStrikeoutSize
    toEnum 1937011311 = OtMetricsTagTBOtMetricsTagStrikeoutOffset
    toEnum 1970168947 = OtMetricsTagTBOtMetricsTagUnderlineSize
    toEnum 1970168943 = OtMetricsTagTBOtMetricsTagUnderlineOffset
    toEnum k = AnotherOtMetricsTagT k

instance P.Ord OtMetricsTagT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag OtMetricsTagT

-- Flags ot_meta_tag_t
-- | Known metadata tags from https:\/\/docs.microsoft.com\/en-us\/typography\/opentype\/spec\/meta
-- 
-- /Since: 2.6.0/
data OtMetaTagT = 
      OtMetaTagTBOtMetaTagDesignLanguages
    -- ^ Design languages. Text, using only
    -- Basic Latin (ASCII) characters. Indicates languages and\/or scripts
    -- for the user audiences that the font was primarily designed for.
    | OtMetaTagTBOtMetaTagSupportedLanguages
    -- ^ Supported languages. Text, using
    -- only Basic Latin (ASCII) characters. Indicates languages and\/or scripts
    -- that the font is declared to be capable of supporting.
    | AnotherOtMetaTagT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum OtMetaTagT where
    fromEnum OtMetaTagTBOtMetaTagDesignLanguages = 1684827751
    fromEnum OtMetaTagTBOtMetaTagSupportedLanguages = 1936485991
    fromEnum (AnotherOtMetaTagT k) = k

    toEnum 1684827751 = OtMetaTagTBOtMetaTagDesignLanguages
    toEnum 1936485991 = OtMetaTagTBOtMetaTagSupportedLanguages
    toEnum k = AnotherOtMetaTagT k

instance P.Ord OtMetaTagT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag OtMetaTagT

-- Flags ot_math_glyph_part_flags_t
-- | Flags for math glyph parts.
-- 
-- /Since: 1.3.3/
data OtMathGlyphPartFlagsT = 
      OtMathGlyphPartFlagsTOtMathGlyphPartFlagExtender
    -- ^ This is an extender glyph part that
    -- can be repeated to reach the desired length.
    | AnotherOtMathGlyphPartFlagsT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum OtMathGlyphPartFlagsT where
    fromEnum OtMathGlyphPartFlagsTOtMathGlyphPartFlagExtender = 1
    fromEnum (AnotherOtMathGlyphPartFlagsT k) = k

    toEnum 1 = OtMathGlyphPartFlagsTOtMathGlyphPartFlagExtender
    toEnum k = AnotherOtMathGlyphPartFlagsT k

instance P.Ord OtMathGlyphPartFlagsT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag OtMathGlyphPartFlagsT

-- Flags ot_layout_baseline_tag_t
-- | Baseline tags from <https://docs.microsoft.com/en-us/typography/opentype/spec/baselinetags Baseline Tags> registry.
-- 
-- /Since: 2.6.0/
data OtLayoutBaselineTagT = 
      OtLayoutBaselineTagTBOtLayoutBaselineTagRoman
    -- ^ The baseline used by alphabetic scripts such as Latin, Cyrillic and Greek.
    -- In vertical writing mode, the alphabetic baseline for characters rotated 90 degrees clockwise.
    -- (This would not apply to alphabetic characters that remain upright in vertical writing mode, since these
    -- characters are not rotated.)
    | OtLayoutBaselineTagTBOtLayoutBaselineTagHanging
    -- ^ The hanging baseline. In horizontal direction, this is the horizontal
    -- line from which syllables seem, to hang in Tibetan and other similar scripts. In vertical writing mode,
    -- for Tibetan (or some other similar script) characters rotated 90 degrees clockwise.
    | OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoFaceBottomOrLeft
    -- ^ Ideographic character face bottom or left edge,
    -- if the direction is horizontal or vertical, respectively.
    | OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoFaceTopOrRight
    -- ^ Ideographic character face top or right edge,
    -- if the direction is horizontal or vertical, respectively.
    | OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoFaceCentral
    -- ^ The center of the ideographic character face. Since: 4.0.0
    | OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoEmboxBottomOrLeft
    -- ^ Ideographic em-box bottom or left edge,
    -- if the direction is horizontal or vertical, respectively.
    | OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoEmboxTopOrRight
    -- ^ Ideographic em-box top or right edge baseline,
    | OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoEmboxCentral
    -- ^ The center of the ideographic em-box. Since: 4.0.0
    -- if the direction is horizontal or vertical, respectively.
    | OtLayoutBaselineTagTBOtLayoutBaselineTagMath
    -- ^ The baseline about which mathematical characters are centered.
    -- In vertical writing mode when mathematical characters rotated 90 degrees clockwise, are centered.
    | AnotherOtLayoutBaselineTagT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum OtLayoutBaselineTagT where
    fromEnum OtLayoutBaselineTagTBOtLayoutBaselineTagRoman = 1919905134
    fromEnum OtLayoutBaselineTagTBOtLayoutBaselineTagHanging = 1751215719
    fromEnum OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoFaceBottomOrLeft = 1768121954
    fromEnum OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoFaceTopOrRight = 1768121972
    fromEnum OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoFaceCentral = 1231251043
    fromEnum OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoEmboxBottomOrLeft = 1768187247
    fromEnum OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoEmboxTopOrRight = 1768191088
    fromEnum OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoEmboxCentral = 1231315813
    fromEnum OtLayoutBaselineTagTBOtLayoutBaselineTagMath = 1835103336
    fromEnum (AnotherOtLayoutBaselineTagT k) = k

    toEnum 1919905134 = OtLayoutBaselineTagTBOtLayoutBaselineTagRoman
    toEnum 1751215719 = OtLayoutBaselineTagTBOtLayoutBaselineTagHanging
    toEnum 1768121954 = OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoFaceBottomOrLeft
    toEnum 1768121972 = OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoFaceTopOrRight
    toEnum 1231251043 = OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoFaceCentral
    toEnum 1768187247 = OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoEmboxBottomOrLeft
    toEnum 1768191088 = OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoEmboxTopOrRight
    toEnum 1231315813 = OtLayoutBaselineTagTBOtLayoutBaselineTagIdeoEmboxCentral
    toEnum 1835103336 = OtLayoutBaselineTagTBOtLayoutBaselineTagMath
    toEnum k = AnotherOtLayoutBaselineTagT k

instance P.Ord OtLayoutBaselineTagT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag OtLayoutBaselineTagT

-- Flags ot_color_palette_flags_t
-- | Flags that describe the properties of color palette.
-- 
-- /Since: 2.1.0/
data OtColorPaletteFlagsT = 
      OtColorPaletteFlagsTDefault
    -- ^ Default indicating that there is nothing special
    --   to note about a color palette.
    | OtColorPaletteFlagsTUsableWithLightBackground
    -- ^ Flag indicating that the color
    --   palette is appropriate to use when displaying the font on a light background such as white.
    | OtColorPaletteFlagsTUsableWithDarkBackground
    -- ^ Flag indicating that the color
    --   palette is appropriate to use when displaying the font on a dark background such as black.
    | AnotherOtColorPaletteFlagsT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum OtColorPaletteFlagsT where
    fromEnum OtColorPaletteFlagsTDefault = 0
    fromEnum OtColorPaletteFlagsTUsableWithLightBackground = 1
    fromEnum OtColorPaletteFlagsTUsableWithDarkBackground = 2
    fromEnum (AnotherOtColorPaletteFlagsT k) = k

    toEnum 0 = OtColorPaletteFlagsTDefault
    toEnum 1 = OtColorPaletteFlagsTUsableWithLightBackground
    toEnum 2 = OtColorPaletteFlagsTUsableWithDarkBackground
    toEnum k = AnotherOtColorPaletteFlagsT k

instance P.Ord OtColorPaletteFlagsT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag OtColorPaletteFlagsT

-- Flags glyph_flags_t
-- | Flags for t'GI.HarfBuzz.Structs.GlyphInfoT.GlyphInfoT'.
-- 
-- /Since: 1.5.0/
data GlyphFlagsT = 
      GlyphFlagsTUnsafeToBreak
    -- ^ Indicates that if input text is broken at the
    -- 				   beginning of the cluster this glyph is part of,
    -- 				   then both sides need to be re-shaped, as the
    -- 				   result might be different.
    -- 				   On the flip side, it means that when this
    -- 				   flag is not present, then it is safe to break
    -- 				   the glyph-run at the beginning of this
    -- 				   cluster, and the two sides will represent the
    -- 				   exact same result one would get if breaking
    -- 				   input text at the beginning of this cluster
    -- 				   and shaping the two sides separately.
    -- 				   This can be used to optimize paragraph
    -- 				   layout, by avoiding re-shaping of each line
    -- 				   after line-breaking.
    | GlyphFlagsTUnsafeToConcat
    -- ^ Indicates that if input text is changed on one
    -- 				   side of the beginning of the cluster this glyph
    -- 				   is part of, then the shaping results for the
    -- 				   other side might change.
    -- 				   Note that the absence of this flag will NOT by
    -- 				   itself mean that it IS safe to concat text.
    -- 				   Only two pieces of text both of which clear of
    -- 				   this flag can be concatenated safely.
    -- 				   This can be used to optimize paragraph
    -- 				   layout, by avoiding re-shaping of each line
    -- 				   after line-breaking, by limiting the
    -- 				   reshaping to a small piece around the
    -- 				   breaking position only, even if the breaking
    -- 				   position carries the
    -- 				   @/HB_GLYPH_FLAG_UNSAFE_TO_BREAK/@ or when
    -- 				   hyphenation or other text transformation
    -- 				   happens at line-break position, in the following
    -- 				   way:
    -- 				   1. Iterate back from the line-break position
    -- 				   until the first cluster start position that is
    -- 				   NOT unsafe-to-concat, 2. shape the segment from
    -- 				   there till the end of line, 3. check whether the
    -- 				   resulting glyph-run also is clear of the
    -- 				   unsafe-to-concat at its start-of-text position;
    -- 				   if it is, just splice it into place and the line
    -- 				   is shaped; If not, move on to a position further
    -- 				   back that is clear of unsafe-to-concat and retry
    -- 				   from there, and repeat.
    -- 				   At the start of next line a similar algorithm can
    -- 				   be implemented. That is: 1. Iterate forward from
    -- 				   the line-break position until the first cluster
    -- 				   start position that is NOT unsafe-to-concat, 2.
    -- 				   shape the segment from beginning of the line to
    -- 				   that position, 3. check whether the resulting
    -- 				   glyph-run also is clear of the unsafe-to-concat
    -- 				   at its end-of-text position; if it is, just splice
    -- 				   it into place and the beginning is shaped; If not,
    -- 				   move on to a position further forward that is clear
    -- 				   of unsafe-to-concat and retry up to there, and repeat.
    -- 				   A slight complication will arise in the
    -- 				   implementation of the algorithm above,
    -- 				   because while our buffer API has a way to
    -- 				   return flags for position corresponding to
    -- 				   start-of-text, there is currently no position
    -- 				   corresponding to end-of-text.  This limitation
    -- 				   can be alleviated by shaping more text than needed
    -- 				   and looking for unsafe-to-concat flag within text
    -- 				   clusters.
    -- 				   The @/HB_GLYPH_FLAG_UNSAFE_TO_BREAK/@ flag will
    -- 				   always imply this flag.
    -- 			   To use this flag, you must enable the buffer flag
    -- 			   /@hBBUFFERFLAGPRODUCEUNSAFETOCONCAT@/ during
    -- 			   shaping, otherwise the buffer flag will not be
    -- 			   reliably produced.
    -- 				   Since: 4.0.0
    | GlyphFlagsTSafeToInsertTatweel
    -- ^ In scripts that use elongation (Arabic,
    -- 				   Mongolian, Syriac, etc.), this flag signifies
    -- 				   that it is safe to insert a U+0640 TATWEEL
    -- 				   character before this cluster for elongation.
    -- 				   This flag does not determine the
    -- 				   script-specific elongation places, but only
    -- 				   when it is safe to do the elongation without
    -- 				   interrupting text shaping.
    -- 				   Since: 5.1.0
    | GlyphFlagsTDefined
    -- ^ All the currently defined flags.
    | AnotherGlyphFlagsT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum GlyphFlagsT where
    fromEnum GlyphFlagsTUnsafeToBreak = 1
    fromEnum GlyphFlagsTUnsafeToConcat = 2
    fromEnum GlyphFlagsTSafeToInsertTatweel = 4
    fromEnum GlyphFlagsTDefined = 7
    fromEnum (AnotherGlyphFlagsT k) = k

    toEnum 1 = GlyphFlagsTUnsafeToBreak
    toEnum 2 = GlyphFlagsTUnsafeToConcat
    toEnum 4 = GlyphFlagsTSafeToInsertTatweel
    toEnum 7 = GlyphFlagsTDefined
    toEnum k = AnotherGlyphFlagsT k

instance P.Ord GlyphFlagsT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag GlyphFlagsT

-- Flags buffer_serialize_format_t
-- | The buffer serialization and de-serialization format used in
-- 'GI.HarfBuzz.Functions.bufferSerializeGlyphs' and 'GI.HarfBuzz.Functions.bufferDeserializeGlyphs'.
-- 
-- /Since: 0.9.2/
data BufferSerializeFormatT = 
      BufferSerializeFormatTText
    -- ^ a human-readable, plain text format.
    | BufferSerializeFormatTJson
    -- ^ a machine-readable JSON format.
    | BufferSerializeFormatTInvalid
    -- ^ invalid format.
    | AnotherBufferSerializeFormatT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum BufferSerializeFormatT where
    fromEnum BufferSerializeFormatTText = 1413830740
    fromEnum BufferSerializeFormatTJson = 1246973774
    fromEnum BufferSerializeFormatTInvalid = 0
    fromEnum (AnotherBufferSerializeFormatT k) = k

    toEnum 1413830740 = BufferSerializeFormatTText
    toEnum 1246973774 = BufferSerializeFormatTJson
    toEnum 0 = BufferSerializeFormatTInvalid
    toEnum k = AnotherBufferSerializeFormatT k

instance P.Ord BufferSerializeFormatT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag BufferSerializeFormatT

-- Flags buffer_serialize_flags_t
-- | Flags that control what glyph information are serialized in 'GI.HarfBuzz.Functions.bufferSerializeGlyphs'.
-- 
-- /Since: 0.9.20/
data BufferSerializeFlagsT = 
      BufferSerializeFlagsTDefault
    -- ^ serialize glyph names, clusters and positions.
    | BufferSerializeFlagsTNoClusters
    -- ^ do not serialize glyph cluster.
    | BufferSerializeFlagsTNoPositions
    -- ^ do not serialize glyph position information.
    | BufferSerializeFlagsTNoGlyphNames
    -- ^ do no serialize glyph name.
    | BufferSerializeFlagsTGlyphExtents
    -- ^ serialize glyph extents.
    | BufferSerializeFlagsTGlyphFlags
    -- ^ serialize glyph flags. Since: 1.5.0
    | BufferSerializeFlagsTNoAdvances
    -- ^ do not serialize glyph advances,
    --  glyph offsets will reflect absolute glyph positions. Since: 1.8.0
    | BufferSerializeFlagsTDefined
    -- ^ All currently defined flags. Since: 4.4.0
    | AnotherBufferSerializeFlagsT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum BufferSerializeFlagsT where
    fromEnum BufferSerializeFlagsTDefault = 0
    fromEnum BufferSerializeFlagsTNoClusters = 1
    fromEnum BufferSerializeFlagsTNoPositions = 2
    fromEnum BufferSerializeFlagsTNoGlyphNames = 4
    fromEnum BufferSerializeFlagsTGlyphExtents = 8
    fromEnum BufferSerializeFlagsTGlyphFlags = 16
    fromEnum BufferSerializeFlagsTNoAdvances = 32
    fromEnum BufferSerializeFlagsTDefined = 63
    fromEnum (AnotherBufferSerializeFlagsT k) = k

    toEnum 0 = BufferSerializeFlagsTDefault
    toEnum 1 = BufferSerializeFlagsTNoClusters
    toEnum 2 = BufferSerializeFlagsTNoPositions
    toEnum 4 = BufferSerializeFlagsTNoGlyphNames
    toEnum 8 = BufferSerializeFlagsTGlyphExtents
    toEnum 16 = BufferSerializeFlagsTGlyphFlags
    toEnum 32 = BufferSerializeFlagsTNoAdvances
    toEnum 63 = BufferSerializeFlagsTDefined
    toEnum k = AnotherBufferSerializeFlagsT k

instance P.Ord BufferSerializeFlagsT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag BufferSerializeFlagsT

-- Flags buffer_flags_t
-- | Flags for t'GI.HarfBuzz.Structs.BufferT.BufferT'.
-- 
-- /Since: 0.9.20/
data BufferFlagsT = 
      BufferFlagsTDefault
    -- ^ the default buffer flag.
    | BufferFlagsTBot
    -- ^ flag indicating that special handling of the beginning
    --                      of text paragraph can be applied to this buffer. Should usually
    --                      be set, unless you are passing to the buffer only part
    --                      of the text without the full context.
    | BufferFlagsTEot
    -- ^ flag indicating that special handling of the end of text
    --                      paragraph can be applied to this buffer, similar to
    --                      /@hBBUFFERFLAGBOT@/.
    | BufferFlagsTPreserveDefaultIgnorables
    -- ^ flag indication that character with Default_Ignorable
    --                      Unicode property should use the corresponding glyph
    --                      from the font, instead of hiding them (done by
    --                      replacing them with the space glyph and zeroing the
    --                      advance width.)  This flag takes precedence over
    --                      /@hBBUFFERFLAGREMOVEDEFAULTIGNORABLES@/.
    | BufferFlagsTRemoveDefaultIgnorables
    -- ^ flag indication that character with Default_Ignorable
    --                      Unicode property should be removed from glyph string
    --                      instead of hiding them (done by replacing them with the
    --                      space glyph and zeroing the advance width.)
    --                      /@hBBUFFERFLAGPRESERVEDEFAULTIGNORABLES@/ takes
    --                      precedence over this flag. Since: 1.8.0
    | BufferFlagsTDoNotInsertDottedCircle
    -- ^ flag indicating that a dotted circle should
    --                      not be inserted in the rendering of incorrect
    --                      character sequences (such at \<0905 093E>). Since: 2.4.0
    | BufferFlagsTVerify
    -- ^ flag indicating that the 'GI.HarfBuzz.Functions.shape' call and its variants
    --                      should perform various verification processes on the results
    --                      of the shaping operation on the buffer.  If the verification
    --                      fails, then either a buffer message is sent, if a message
    --                      handler is installed on the buffer, or a message is written
    --                      to standard error.  In either case, the shaping result might
    --                      be modified to show the failed output. Since: 3.4.0
    | BufferFlagsTProduceUnsafeToConcat
    -- ^ flag indicating that the /@hBGLYPHFLAGUNSAFETOCONCAT@/
    --                      glyph-flag should be produced by the shaper. By default
    --                      it will not be produced since it incurs a cost. Since: 4.0.0
    | BufferFlagsTProduceSafeToInsertTatweel
    -- ^ flag indicating that the /@hBGLYPHFLAGSAFETOINSERTTATWEEL@/
    --                      glyph-flag should be produced by the shaper. By default
    --                      it will not be produced. Since: 5.1.0
    | BufferFlagsTDefined
    -- ^ All currently defined flags: Since: 4.4.0
    | AnotherBufferFlagsT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum BufferFlagsT where
    fromEnum BufferFlagsTDefault = 0
    fromEnum BufferFlagsTBot = 1
    fromEnum BufferFlagsTEot = 2
    fromEnum BufferFlagsTPreserveDefaultIgnorables = 4
    fromEnum BufferFlagsTRemoveDefaultIgnorables = 8
    fromEnum BufferFlagsTDoNotInsertDottedCircle = 16
    fromEnum BufferFlagsTVerify = 32
    fromEnum BufferFlagsTProduceUnsafeToConcat = 64
    fromEnum BufferFlagsTProduceSafeToInsertTatweel = 128
    fromEnum BufferFlagsTDefined = 255
    fromEnum (AnotherBufferFlagsT k) = k

    toEnum 0 = BufferFlagsTDefault
    toEnum 1 = BufferFlagsTBot
    toEnum 2 = BufferFlagsTEot
    toEnum 4 = BufferFlagsTPreserveDefaultIgnorables
    toEnum 8 = BufferFlagsTRemoveDefaultIgnorables
    toEnum 16 = BufferFlagsTDoNotInsertDottedCircle
    toEnum 32 = BufferFlagsTVerify
    toEnum 64 = BufferFlagsTProduceUnsafeToConcat
    toEnum 128 = BufferFlagsTProduceSafeToInsertTatweel
    toEnum 255 = BufferFlagsTDefined
    toEnum k = AnotherBufferFlagsT k

instance P.Ord BufferFlagsT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag BufferFlagsT

-- Flags buffer_diff_flags_t
-- | Flags from comparing two t'GI.HarfBuzz.Structs.BufferT.BufferT'\'s.
-- 
-- Buffer with different t'GI.HarfBuzz.Enums.BufferContentTypeT' cannot be meaningfully
-- compared in any further detail.
-- 
-- For buffers with differing length, the per-glyph comparison is not
-- attempted, though we do still scan reference buffer for dotted circle and
-- @.notdef@ glyphs.
-- 
-- If the buffers have the same length, we compare them glyph-by-glyph and
-- report which aspect(s) of the glyph info\/position are different.
-- 
-- /Since: 1.5.0/
data BufferDiffFlagsT = 
      BufferDiffFlagsTEqual
    -- ^ equal buffers.
    | BufferDiffFlagsTContentTypeMismatch
    -- ^ buffers with different
    --     t'GI.HarfBuzz.Enums.BufferContentTypeT'.
    | BufferDiffFlagsTLengthMismatch
    -- ^ buffers with differing length.
    | BufferDiffFlagsTNotdefPresent
    -- ^ @.notdef@ glyph is present in the
    --     reference buffer.
    | BufferDiffFlagsTDottedCirclePresent
    -- ^ dotted circle glyph is present
    --     in the reference buffer.
    | BufferDiffFlagsTCodepointMismatch
    -- ^ difference in t'GI.HarfBuzz.Structs.GlyphInfoT.GlyphInfoT'.@/codepoint/@
    | BufferDiffFlagsTClusterMismatch
    -- ^ difference in t'GI.HarfBuzz.Structs.GlyphInfoT.GlyphInfoT'.@/cluster/@
    | BufferDiffFlagsTGlyphFlagsMismatch
    -- ^ difference in t'GI.HarfBuzz.Flags.GlyphFlagsT'.
    | BufferDiffFlagsTPositionMismatch
    -- ^ difference in t'GI.HarfBuzz.Structs.GlyphPositionT.GlyphPositionT'.
    | AnotherBufferDiffFlagsT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum BufferDiffFlagsT where
    fromEnum BufferDiffFlagsTEqual = 0
    fromEnum BufferDiffFlagsTContentTypeMismatch = 1
    fromEnum BufferDiffFlagsTLengthMismatch = 2
    fromEnum BufferDiffFlagsTNotdefPresent = 4
    fromEnum BufferDiffFlagsTDottedCirclePresent = 8
    fromEnum BufferDiffFlagsTCodepointMismatch = 16
    fromEnum BufferDiffFlagsTClusterMismatch = 32
    fromEnum BufferDiffFlagsTGlyphFlagsMismatch = 64
    fromEnum BufferDiffFlagsTPositionMismatch = 128
    fromEnum (AnotherBufferDiffFlagsT k) = k

    toEnum 0 = BufferDiffFlagsTEqual
    toEnum 1 = BufferDiffFlagsTContentTypeMismatch
    toEnum 2 = BufferDiffFlagsTLengthMismatch
    toEnum 4 = BufferDiffFlagsTNotdefPresent
    toEnum 8 = BufferDiffFlagsTDottedCirclePresent
    toEnum 16 = BufferDiffFlagsTCodepointMismatch
    toEnum 32 = BufferDiffFlagsTClusterMismatch
    toEnum 64 = BufferDiffFlagsTGlyphFlagsMismatch
    toEnum 128 = BufferDiffFlagsTPositionMismatch
    toEnum k = AnotherBufferDiffFlagsT k

instance P.Ord BufferDiffFlagsT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag BufferDiffFlagsT

-- Flags aat_layout_feature_type_t
-- | The possible feature types defined for AAT shaping, from Apple <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html Font Feature Registry>.
-- 
-- /Since: 2.2.0/
data AatLayoutFeatureTypeT = 
      AatLayoutFeatureTypeTBAatLayoutFeatureTypeInvalid
    -- ^ Initial, unset feature type
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeAllTypographic
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type0 All Typographic Features>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeLigatures
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type1 Ligatures>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeCursiveConnection
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type2 Cursive Connection>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeLetterCase
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type3 Letter Case>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeVerticalSubstitution
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type4 Vertical Substitution>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeLinguisticRearrangement
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type5 Linguistic Rearrangement>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeNumberSpacing
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type6 Number Spacing>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeSmartSwashType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type8 Smart Swash>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeDiacriticsType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type9 Diacritics>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeVerticalPosition
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type10 Vertical Position>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeFractions
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type11 Fractions>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeOverlappingCharactersType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type13 Overlapping Characters>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeTypographicExtras
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type14 Typographic Extras>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeMathematicalExtras
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type15 Mathematical Extras>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeOrnamentSetsType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type16 Ornament Sets>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeCharacterAlternatives
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type17 Character Alternatives>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeDesignComplexityType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type18 Design Complexity>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeStyleOptions
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type19 Style Options>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeCharacterShape
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type20 Character Shape>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeNumberCase
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type21 Number Case>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeTextSpacing
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type22 Text Spacing>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeTransliteration
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type23 Transliteration>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeAnnotationType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type24 Annotation>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeKanaSpacingType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type25 Kana Spacing>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeIdeographicSpacingType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type26 Ideographic Spacing>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeUnicodeDecompositionType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type27 Unicode Decomposition>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeRubyKana
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type28 Ruby Kana>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeCjkSymbolAlternativesType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type29 CJK Symbol Alternatives>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeIdeographicAlternativesType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type30 Ideographic Alternatives>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeCjkVerticalRomanPlacementType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type31 CJK Vertical Roman Placement>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeItalicCjkRoman
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type32 Italic CJK Roman>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeCaseSensitiveLayout
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type33 Case Sensitive Layout>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeAlternateKana
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type34 Alternate Kana>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeStylisticAlternatives
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type35 Stylistic Alternatives>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeContextualAlternatives
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type36 Contextual Alternatives>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeLowerCase
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type37 Lower Case>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeUpperCase
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type38 Upper Case>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeLanguageTagType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type39 Language Tag>
    | AatLayoutFeatureTypeTBAatLayoutFeatureTypeCjkRomanSpacingType
    -- ^ <https://developer.apple.com/fonts/TrueType-Reference-Manual/RM09/AppendixF.html#Type103 CJK Roman Spacing>
    | AnotherAatLayoutFeatureTypeT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum AatLayoutFeatureTypeT where
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeInvalid = 65535
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeAllTypographic = 0
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeLigatures = 1
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeCursiveConnection = 2
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeLetterCase = 3
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeVerticalSubstitution = 4
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeLinguisticRearrangement = 5
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeNumberSpacing = 6
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeSmartSwashType = 8
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeDiacriticsType = 9
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeVerticalPosition = 10
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeFractions = 11
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeOverlappingCharactersType = 13
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeTypographicExtras = 14
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeMathematicalExtras = 15
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeOrnamentSetsType = 16
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeCharacterAlternatives = 17
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeDesignComplexityType = 18
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeStyleOptions = 19
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeCharacterShape = 20
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeNumberCase = 21
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeTextSpacing = 22
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeTransliteration = 23
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeAnnotationType = 24
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeKanaSpacingType = 25
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeIdeographicSpacingType = 26
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeUnicodeDecompositionType = 27
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeRubyKana = 28
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeCjkSymbolAlternativesType = 29
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeIdeographicAlternativesType = 30
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeCjkVerticalRomanPlacementType = 31
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeItalicCjkRoman = 32
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeCaseSensitiveLayout = 33
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeAlternateKana = 34
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeStylisticAlternatives = 35
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeContextualAlternatives = 36
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeLowerCase = 37
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeUpperCase = 38
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeLanguageTagType = 39
    fromEnum AatLayoutFeatureTypeTBAatLayoutFeatureTypeCjkRomanSpacingType = 103
    fromEnum (AnotherAatLayoutFeatureTypeT k) = k

    toEnum 65535 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeInvalid
    toEnum 0 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeAllTypographic
    toEnum 1 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeLigatures
    toEnum 2 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeCursiveConnection
    toEnum 3 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeLetterCase
    toEnum 4 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeVerticalSubstitution
    toEnum 5 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeLinguisticRearrangement
    toEnum 6 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeNumberSpacing
    toEnum 8 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeSmartSwashType
    toEnum 9 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeDiacriticsType
    toEnum 10 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeVerticalPosition
    toEnum 11 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeFractions
    toEnum 13 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeOverlappingCharactersType
    toEnum 14 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeTypographicExtras
    toEnum 15 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeMathematicalExtras
    toEnum 16 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeOrnamentSetsType
    toEnum 17 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeCharacterAlternatives
    toEnum 18 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeDesignComplexityType
    toEnum 19 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeStyleOptions
    toEnum 20 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeCharacterShape
    toEnum 21 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeNumberCase
    toEnum 22 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeTextSpacing
    toEnum 23 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeTransliteration
    toEnum 24 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeAnnotationType
    toEnum 25 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeKanaSpacingType
    toEnum 26 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeIdeographicSpacingType
    toEnum 27 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeUnicodeDecompositionType
    toEnum 28 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeRubyKana
    toEnum 29 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeCjkSymbolAlternativesType
    toEnum 30 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeIdeographicAlternativesType
    toEnum 31 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeCjkVerticalRomanPlacementType
    toEnum 32 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeItalicCjkRoman
    toEnum 33 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeCaseSensitiveLayout
    toEnum 34 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeAlternateKana
    toEnum 35 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeStylisticAlternatives
    toEnum 36 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeContextualAlternatives
    toEnum 37 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeLowerCase
    toEnum 38 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeUpperCase
    toEnum 39 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeLanguageTagType
    toEnum 103 = AatLayoutFeatureTypeTBAatLayoutFeatureTypeCjkRomanSpacingType
    toEnum k = AnotherAatLayoutFeatureTypeT k

instance P.Ord AatLayoutFeatureTypeT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag AatLayoutFeatureTypeT

-- Flags aat_layout_feature_selector_t
-- | The selectors defined for specifying AAT feature settings.
-- 
-- /Since: 2.2.0/
data AatLayoutFeatureSelectorT = 
      AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInvalid
    -- ^ Initial, unset feature selector
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAllTypeFeaturesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ALL_TYPOGRAPHIC/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAllTypeFeaturesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ALL_TYPOGRAPHIC/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRequiredLigaturesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRequiredLigaturesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCommonLigaturesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCommonLigaturesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRareLigaturesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRareLigaturesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLogosOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLogosOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRebusPicturesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRebusPicturesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDiphthongLigaturesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDiphthongLigaturesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSquaredLigaturesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSquaredLigaturesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAbbrevSquaredLigaturesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAbbrevSquaredLigaturesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSymbolLigaturesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSymbolLigaturesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualLigaturesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualLigaturesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHistoricalLigaturesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHistoricalLigaturesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorUnconnected
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPartiallyConnected
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCursive
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LIGATURES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorUpperAndLowerCase
    -- ^ Deprecated
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAllCaps
    -- ^ Deprecated
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAllLowerCase
    -- ^ Deprecated
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSmallCaps
    -- ^ Deprecated
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInitialCaps
    -- ^ Deprecated
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInitialCapsAndSmallCaps
    -- ^ Deprecated
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSubstituteVerticalFormsOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_VERTICAL_SUBSTITUTION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSubstituteVerticalFormsOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_VERTICAL_SUBSTITUTION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLinguisticRearrangementOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LINGUISTIC_REARRANGEMENT/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLinguisticRearrangementOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LINGUISTIC_REARRANGEMENT/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorMonospacedNumbers
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_NUMBER_SPACING/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorProportionalNumbers
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_NUMBER_SPACING/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorThirdWidthNumbers
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_NUMBER_SPACING/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorQuarterWidthNumbers
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_NUMBER_SPACING/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorWordInitialSwashesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_SMART_SWASH_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorWordInitialSwashesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_SMART_SWASH_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorWordFinalSwashesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_SMART_SWASH_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorWordFinalSwashesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_SMART_SWASH_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLineInitialSwashesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_SMART_SWASH_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLineInitialSwashesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_SMART_SWASH_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLineFinalSwashesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_SMART_SWASH_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLineFinalSwashesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_SMART_SWASH_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNonFinalSwashesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_SMART_SWASH_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNonFinalSwashesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_SMART_SWASH_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorShowDiacritics
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_DIACRITICS_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHideDiacritics
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_DIACRITICS_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDecomposeDiacritics
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_DIACRITICS_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNormalPosition
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_VERTICAL_POSITION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSuperiors
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_VERTICAL_POSITION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInferiors
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_VERTICAL_POSITION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorOrdinals
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_VERTICAL_POSITION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorScientificInferiors
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_VERTICAL_POSITION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoFractions
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_FRACTIONS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorVerticalFractions
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_FRACTIONS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDiagonalFractions
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_FRACTIONS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPreventOverlapOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_OVERLAPPING_CHARACTERS_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPreventOverlapOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_OVERLAPPING_CHARACTERS_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHyphensToEmDashOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TYPOGRAPHIC_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHyphensToEmDashOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TYPOGRAPHIC_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHyphenToEnDashOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TYPOGRAPHIC_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHyphenToEnDashOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TYPOGRAPHIC_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSlashedZeroOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TYPOGRAPHIC_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSlashedZeroOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TYPOGRAPHIC_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorFormInterrobangOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TYPOGRAPHIC_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorFormInterrobangOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TYPOGRAPHIC_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSmartQuotesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TYPOGRAPHIC_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSmartQuotesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TYPOGRAPHIC_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPeriodsToEllipsisOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TYPOGRAPHIC_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPeriodsToEllipsisOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TYPOGRAPHIC_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHyphenToMinusOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_MATHEMATICAL_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHyphenToMinusOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_MATHEMATICAL_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAsteriskToMultiplyOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_MATHEMATICAL_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAsteriskToMultiplyOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_MATHEMATICAL_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSlashToDivideOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_MATHEMATICAL_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSlashToDivideOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_MATHEMATICAL_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInequalityLigaturesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_MATHEMATICAL_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInequalityLigaturesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_MATHEMATICAL_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorExponentsOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_MATHEMATICAL_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorExponentsOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_MATHEMATICAL_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorMathematicalGreekOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_MATHEMATICAL_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorMathematicalGreekOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_MATHEMATICAL_EXTRAS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoOrnaments
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ORNAMENT_SETS_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDingbats
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ORNAMENT_SETS_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPiCharacters
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ORNAMENT_SETS_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorFleurons
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ORNAMENT_SETS_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDecorativeBorders
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ORNAMENT_SETS_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInternationalSymbols
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ORNAMENT_SETS_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorMathSymbols
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ORNAMENT_SETS_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoAlternates
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDesignLevel1
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_DESIGN_COMPLEXITY_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDesignLevel2
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_DESIGN_COMPLEXITY_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDesignLevel3
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_DESIGN_COMPLEXITY_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDesignLevel4
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_DESIGN_COMPLEXITY_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDesignLevel5
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_DESIGN_COMPLEXITY_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoStyleOptions
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLE_OPTIONS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDisplayText
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLE_OPTIONS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorEngravedText
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLE_OPTIONS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorIlluminatedCaps
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLE_OPTIONS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTitlingCaps
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLE_OPTIONS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTallCaps
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLE_OPTIONS/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalCharacters
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSimplifiedCharacters
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorJis1978Characters
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorJis1983Characters
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorJis1990Characters
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalAltOne
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalAltTwo
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalAltThree
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalAltFour
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalAltFive
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorExpertCharacters
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorJis2004Characters
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHojoCharacters
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNlccharacters
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalNamesCharacters
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CHARACTER_SHAPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLowerCaseNumbers
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_NUMBER_CASE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorUpperCaseNumbers
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_NUMBER_CASE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorProportionalText
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TEXT_SPACING/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorMonospacedText
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TEXT_SPACING/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHalfWidthText
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TEXT_SPACING/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorThirdWidthText
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TEXT_SPACING/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorQuarterWidthText
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TEXT_SPACING/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAltProportionalText
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TEXT_SPACING/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAltHalfWidthText
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TEXT_SPACING/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoTransliteration
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TRANSLITERATION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHanjaToHangul
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TRANSLITERATION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHiraganaToKatakana
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TRANSLITERATION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorKatakanaToHiragana
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TRANSLITERATION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorKanaToRomanization
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TRANSLITERATION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRomanizationToHiragana
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TRANSLITERATION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRomanizationToKatakana
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TRANSLITERATION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHanjaToHangulAltOne
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TRANSLITERATION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHanjaToHangulAltTwo
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TRANSLITERATION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHanjaToHangulAltThree
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_TRANSLITERATION/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoAnnotation
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ANNOTATION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorBoxAnnotation
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ANNOTATION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRoundedBoxAnnotation
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ANNOTATION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCircleAnnotation
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ANNOTATION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInvertedCircleAnnotation
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ANNOTATION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorParenthesisAnnotation
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ANNOTATION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPeriodAnnotation
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ANNOTATION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRomanNumeralAnnotation
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ANNOTATION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDiamondAnnotation
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ANNOTATION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInvertedBoxAnnotation
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ANNOTATION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInvertedRoundedBoxAnnotation
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ANNOTATION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorFullWidthKana
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_KANA_SPACING_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorProportionalKana
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_KANA_SPACING_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorFullWidthIdeographs
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_IDEOGRAPHIC_SPACING_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorProportionalIdeographs
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_IDEOGRAPHIC_SPACING_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHalfWidthIdeographs
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_IDEOGRAPHIC_SPACING_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCanonicalCompositionOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_UNICODE_DECOMPOSITION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCanonicalCompositionOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_UNICODE_DECOMPOSITION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCompatibilityCompositionOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_UNICODE_DECOMPOSITION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCompatibilityCompositionOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_UNICODE_DECOMPOSITION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTranscodingCompositionOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_UNICODE_DECOMPOSITION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTranscodingCompositionOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_UNICODE_DECOMPOSITION_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoRubyKana
    -- ^ Deprecated; use @/HB_AAT_LAYOUT_FEATURE_SELECTOR_RUBY_KANA_OFF/@ instead
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRubyKana
    -- ^ Deprecated; use @/HB_AAT_LAYOUT_FEATURE_SELECTOR_RUBY_KANA_ON/@ instead
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRubyKanaOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_RUBY_KANA/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRubyKanaOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_RUBY_KANA/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoCjkSymbolAlternatives
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CJK_SYMBOL_ALTERNATIVES_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkSymbolAltOne
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CJK_SYMBOL_ALTERNATIVES_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkSymbolAltTwo
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CJK_SYMBOL_ALTERNATIVES_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkSymbolAltThree
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CJK_SYMBOL_ALTERNATIVES_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkSymbolAltFour
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CJK_SYMBOL_ALTERNATIVES_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkSymbolAltFive
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CJK_SYMBOL_ALTERNATIVES_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoIdeographicAlternatives
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_IDEOGRAPHIC_ALTERNATIVES_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorIdeographicAltOne
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_IDEOGRAPHIC_ALTERNATIVES_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorIdeographicAltTwo
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_IDEOGRAPHIC_ALTERNATIVES_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorIdeographicAltThree
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_IDEOGRAPHIC_ALTERNATIVES_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorIdeographicAltFour
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_IDEOGRAPHIC_ALTERNATIVES_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorIdeographicAltFive
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_IDEOGRAPHIC_ALTERNATIVES_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkVerticalRomanCentered
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CJK_VERTICAL_ROMAN_PLACEMENT_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkVerticalRomanHbaseline
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CJK_VERTICAL_ROMAN_PLACEMENT_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoCjkItalicRoman
    -- ^ Deprecated; use @/HB_AAT_LAYOUT_FEATURE_SELECTOR_CJK_ITALIC_ROMAN_OFF/@ instead
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkItalicRoman
    -- ^ Deprecated; use @/HB_AAT_LAYOUT_FEATURE_SELECTOR_CJK_ITALIC_ROMAN_ON/@ instead
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkItalicRomanOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ITALIC_CJK_ROMAN/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkItalicRomanOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ITALIC_CJK_ROMAN/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCaseSensitiveLayoutOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CASE_SENSITIVE_LAYOUT/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCaseSensitiveLayoutOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CASE_SENSITIVE_LAYOUT/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCaseSensitiveSpacingOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CASE_SENSITIVE_LAYOUT/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCaseSensitiveSpacingOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CASE_SENSITIVE_LAYOUT/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAlternateHorizKanaOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ALTERNATE_KANA/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAlternateHorizKanaOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ALTERNATE_KANA/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAlternateVertKanaOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ALTERNATE_KANA/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAlternateVertKanaOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_ALTERNATE_KANA/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoStylisticAlternates
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltOneOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltOneOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwoOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwoOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltThreeOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltThreeOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFourOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFourOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFiveOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFiveOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSixOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSixOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSevenOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSevenOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltEightOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltEightOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltNineOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltNineOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTenOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTenOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltElevenOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltElevenOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwelveOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwelveOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltThirteenOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltThirteenOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFourteenOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFourteenOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFifteenOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFifteenOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSixteenOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSixteenOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSeventeenOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSeventeenOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltEighteenOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltEighteenOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltNineteenOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltNineteenOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwentyOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwentyOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_STYLISTIC_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualAlternatesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CONTEXTUAL_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualAlternatesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CONTEXTUAL_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSwashAlternatesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CONTEXTUAL_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSwashAlternatesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CONTEXTUAL_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualSwashAlternatesOn
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CONTEXTUAL_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualSwashAlternatesOff
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CONTEXTUAL_ALTERNATIVES/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDefaultLowerCase
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LOWER_CASE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLowerCaseSmallCaps
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LOWER_CASE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLowerCasePetiteCaps
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_LOWER_CASE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDefaultUpperCase
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_UPPER_CASE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorUpperCaseSmallCaps
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_UPPER_CASE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorUpperCasePetiteCaps
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_UPPER_CASE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHalfWidthCjkRoman
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CJK_ROMAN_SPACING_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorProportionalCjkRoman
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CJK_ROMAN_SPACING_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDefaultCjkRoman
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CJK_ROMAN_SPACING_TYPE/@
    | AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorFullWidthCjkRoman
    -- ^ for @/HB_AAT_LAYOUT_FEATURE_TYPE_CJK_ROMAN_SPACING_TYPE/@
    | AnotherAatLayoutFeatureSelectorT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum AatLayoutFeatureSelectorT where
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInvalid = 65535
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAllTypeFeaturesOn = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAllTypeFeaturesOff = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRequiredLigaturesOn = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRequiredLigaturesOff = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCommonLigaturesOn = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCommonLigaturesOff = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRareLigaturesOn = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRareLigaturesOff = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLogosOn = 6
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLogosOff = 7
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRebusPicturesOn = 8
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRebusPicturesOff = 9
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDiphthongLigaturesOn = 10
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDiphthongLigaturesOff = 11
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSquaredLigaturesOn = 12
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSquaredLigaturesOff = 13
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAbbrevSquaredLigaturesOn = 14
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAbbrevSquaredLigaturesOff = 15
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSymbolLigaturesOn = 16
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSymbolLigaturesOff = 17
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualLigaturesOn = 18
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualLigaturesOff = 19
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHistoricalLigaturesOn = 20
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHistoricalLigaturesOff = 21
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorUnconnected = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPartiallyConnected = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCursive = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorUpperAndLowerCase = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAllCaps = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAllLowerCase = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSmallCaps = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInitialCaps = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInitialCapsAndSmallCaps = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSubstituteVerticalFormsOn = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSubstituteVerticalFormsOff = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLinguisticRearrangementOn = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLinguisticRearrangementOff = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorMonospacedNumbers = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorProportionalNumbers = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorThirdWidthNumbers = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorQuarterWidthNumbers = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorWordInitialSwashesOn = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorWordInitialSwashesOff = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorWordFinalSwashesOn = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorWordFinalSwashesOff = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLineInitialSwashesOn = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLineInitialSwashesOff = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLineFinalSwashesOn = 6
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLineFinalSwashesOff = 7
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNonFinalSwashesOn = 8
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNonFinalSwashesOff = 9
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorShowDiacritics = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHideDiacritics = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDecomposeDiacritics = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNormalPosition = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSuperiors = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInferiors = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorOrdinals = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorScientificInferiors = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoFractions = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorVerticalFractions = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDiagonalFractions = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPreventOverlapOn = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPreventOverlapOff = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHyphensToEmDashOn = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHyphensToEmDashOff = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHyphenToEnDashOn = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHyphenToEnDashOff = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSlashedZeroOn = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSlashedZeroOff = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorFormInterrobangOn = 6
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorFormInterrobangOff = 7
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSmartQuotesOn = 8
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSmartQuotesOff = 9
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPeriodsToEllipsisOn = 10
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPeriodsToEllipsisOff = 11
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHyphenToMinusOn = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHyphenToMinusOff = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAsteriskToMultiplyOn = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAsteriskToMultiplyOff = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSlashToDivideOn = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSlashToDivideOff = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInequalityLigaturesOn = 6
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInequalityLigaturesOff = 7
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorExponentsOn = 8
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorExponentsOff = 9
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorMathematicalGreekOn = 10
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorMathematicalGreekOff = 11
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoOrnaments = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDingbats = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPiCharacters = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorFleurons = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDecorativeBorders = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInternationalSymbols = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorMathSymbols = 6
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoAlternates = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDesignLevel1 = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDesignLevel2 = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDesignLevel3 = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDesignLevel4 = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDesignLevel5 = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoStyleOptions = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDisplayText = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorEngravedText = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorIlluminatedCaps = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTitlingCaps = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTallCaps = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalCharacters = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSimplifiedCharacters = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorJis1978Characters = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorJis1983Characters = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorJis1990Characters = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalAltOne = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalAltTwo = 6
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalAltThree = 7
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalAltFour = 8
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalAltFive = 9
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorExpertCharacters = 10
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorJis2004Characters = 11
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHojoCharacters = 12
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNlccharacters = 13
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTraditionalNamesCharacters = 14
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLowerCaseNumbers = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorUpperCaseNumbers = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorProportionalText = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorMonospacedText = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHalfWidthText = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorThirdWidthText = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorQuarterWidthText = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAltProportionalText = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAltHalfWidthText = 6
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoTransliteration = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHanjaToHangul = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHiraganaToKatakana = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorKatakanaToHiragana = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorKanaToRomanization = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRomanizationToHiragana = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRomanizationToKatakana = 6
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHanjaToHangulAltOne = 7
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHanjaToHangulAltTwo = 8
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHanjaToHangulAltThree = 9
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoAnnotation = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorBoxAnnotation = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRoundedBoxAnnotation = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCircleAnnotation = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInvertedCircleAnnotation = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorParenthesisAnnotation = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorPeriodAnnotation = 6
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRomanNumeralAnnotation = 7
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDiamondAnnotation = 8
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInvertedBoxAnnotation = 9
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInvertedRoundedBoxAnnotation = 10
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorFullWidthKana = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorProportionalKana = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorFullWidthIdeographs = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorProportionalIdeographs = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHalfWidthIdeographs = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCanonicalCompositionOn = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCanonicalCompositionOff = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCompatibilityCompositionOn = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCompatibilityCompositionOff = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTranscodingCompositionOn = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorTranscodingCompositionOff = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoRubyKana = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRubyKana = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRubyKanaOn = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRubyKanaOff = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoCjkSymbolAlternatives = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkSymbolAltOne = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkSymbolAltTwo = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkSymbolAltThree = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkSymbolAltFour = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkSymbolAltFive = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoIdeographicAlternatives = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorIdeographicAltOne = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorIdeographicAltTwo = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorIdeographicAltThree = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorIdeographicAltFour = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorIdeographicAltFive = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkVerticalRomanCentered = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkVerticalRomanHbaseline = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoCjkItalicRoman = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkItalicRoman = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkItalicRomanOn = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCjkItalicRomanOff = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCaseSensitiveLayoutOn = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCaseSensitiveLayoutOff = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCaseSensitiveSpacingOn = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCaseSensitiveSpacingOff = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAlternateHorizKanaOn = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAlternateHorizKanaOff = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAlternateVertKanaOn = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAlternateVertKanaOff = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorNoStylisticAlternates = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltOneOn = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltOneOff = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwoOn = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwoOff = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltThreeOn = 6
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltThreeOff = 7
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFourOn = 8
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFourOff = 9
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFiveOn = 10
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFiveOff = 11
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSixOn = 12
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSixOff = 13
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSevenOn = 14
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSevenOff = 15
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltEightOn = 16
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltEightOff = 17
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltNineOn = 18
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltNineOff = 19
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTenOn = 20
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTenOff = 21
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltElevenOn = 22
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltElevenOff = 23
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwelveOn = 24
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwelveOff = 25
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltThirteenOn = 26
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltThirteenOff = 27
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFourteenOn = 28
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFourteenOff = 29
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFifteenOn = 30
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFifteenOff = 31
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSixteenOn = 32
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSixteenOff = 33
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSeventeenOn = 34
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSeventeenOff = 35
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltEighteenOn = 36
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltEighteenOff = 37
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltNineteenOn = 38
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltNineteenOff = 39
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwentyOn = 40
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwentyOff = 41
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualAlternatesOn = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualAlternatesOff = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSwashAlternatesOn = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSwashAlternatesOff = 3
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualSwashAlternatesOn = 4
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualSwashAlternatesOff = 5
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDefaultLowerCase = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLowerCaseSmallCaps = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLowerCasePetiteCaps = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDefaultUpperCase = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorUpperCaseSmallCaps = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorUpperCasePetiteCaps = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHalfWidthCjkRoman = 0
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorProportionalCjkRoman = 1
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDefaultCjkRoman = 2
    fromEnum AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorFullWidthCjkRoman = 3
    fromEnum (AnotherAatLayoutFeatureSelectorT k) = k

    toEnum 65535 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorInvalid
    toEnum 0 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAllTypeFeaturesOn
    toEnum 1 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAllTypeFeaturesOff
    toEnum 2 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCommonLigaturesOn
    toEnum 3 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorCommonLigaturesOff
    toEnum 4 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRareLigaturesOn
    toEnum 5 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRareLigaturesOff
    toEnum 6 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLogosOn
    toEnum 7 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorLogosOff
    toEnum 8 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRebusPicturesOn
    toEnum 9 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorRebusPicturesOff
    toEnum 10 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDiphthongLigaturesOn
    toEnum 11 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorDiphthongLigaturesOff
    toEnum 12 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSquaredLigaturesOn
    toEnum 13 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSquaredLigaturesOff
    toEnum 14 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAbbrevSquaredLigaturesOn
    toEnum 15 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorAbbrevSquaredLigaturesOff
    toEnum 16 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSymbolLigaturesOn
    toEnum 17 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorSymbolLigaturesOff
    toEnum 18 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualLigaturesOn
    toEnum 19 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorContextualLigaturesOff
    toEnum 20 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHistoricalLigaturesOn
    toEnum 21 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorHistoricalLigaturesOff
    toEnum 22 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltElevenOn
    toEnum 23 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltElevenOff
    toEnum 24 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwelveOn
    toEnum 25 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwelveOff
    toEnum 26 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltThirteenOn
    toEnum 27 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltThirteenOff
    toEnum 28 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFourteenOn
    toEnum 29 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFourteenOff
    toEnum 30 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFifteenOn
    toEnum 31 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltFifteenOff
    toEnum 32 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSixteenOn
    toEnum 33 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSixteenOff
    toEnum 34 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSeventeenOn
    toEnum 35 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltSeventeenOff
    toEnum 36 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltEighteenOn
    toEnum 37 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltEighteenOff
    toEnum 38 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltNineteenOn
    toEnum 39 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltNineteenOff
    toEnum 40 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwentyOn
    toEnum 41 = AatLayoutFeatureSelectorTBAatLayoutFeatureSelectorStylisticAltTwentyOff
    toEnum k = AnotherAatLayoutFeatureSelectorT k

instance P.Ord AatLayoutFeatureSelectorT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

instance IsGFlag AatLayoutFeatureSelectorT


